import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import PropTypes from 'prop-types';
import { inject, observer } from 'mobx-react';
import classnames from 'classnames';
import withStyles from '@material-ui/core/styles/withStyles';
import Button from '@material-ui/core/Button';
import Snackbar from '@material-ui/core/Snackbar';
import IconButton from '@material-ui/core/IconButton';
import CloseIcon from '@material-ui/icons/Close';
import Track from './Track';
import Link from './Link';
/**
 * A button that when clicked adds the specified product to the cart
 */

export var styles = function styles(theme) {
  return {
    root: {},
    docked: {
      fontSize: theme.typography.subheading.fontSize,
      padding: "".concat(theme.margins.container, "px"),
      position: 'fixed',
      left: 0,
      bottom: 0,
      width: '100%',
      zIndex: 10,
      borderRadius: '0'
    },
    confirmation: {
      padding: '2px 0'
    },
    cartLink: {
      color: 'white'
    }
  };
};
var AddToCartButton = (_dec = withStyles(styles, {
  name: 'RSFAddToCartButton'
}), _dec2 = inject(function (_ref) {
  var app = _ref.app,
      ampFormId = _ref.ampFormId;
  return {
    cart: app.cart,
    ampFormId: ampFormId
  };
}), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AddToCartButton, _Component);

  function AddToCartButton() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, AddToCartButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(AddToCartButton)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      messageOpen: false,
      disabled: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleClose", function (event, reason) {
      if (reason === 'clickaway') return;

      _this.setState({
        messageOpen: false
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function (e) {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          throttleClick = _this$props.throttleClick;

      if (_this.props.throttleClick) {
        _this.setState({
          disabled: true
        });

        setTimeout(function () {
          return _this.setState({
            disabled: false
          });
        }, throttleClick);
      }

      if (onClick) {
        onClick(e);
      }

      if (!e.defaultPrevented) {
        if (_this.props.confirmation) {
          _this.setState({
            messageOpen: true
          });
        }

        _this.props.cart.add(_this.props.product);
      }
    });

    return _this;
  }

  _createClass(AddToCartButton, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          product = _this$props2.product,
          ampFormId = _this$props2.ampFormId,
          children = _this$props2.children,
          classes = _this$props2.classes,
          className = _this$props2.className,
          cart = _this$props2.cart,
          docked = _this$props2.docked,
          confirmation = _this$props2.confirmation,
          snackbarProps = _this$props2.snackbarProps,
          cartURL = _this$props2.cartURL,
          cartLinkText = _this$props2.cartLinkText,
          throttleClick = _this$props2.throttleClick,
          disabled = _this$props2.disabled,
          other = _objectWithoutProperties(_this$props2, ["product", "ampFormId", "children", "classes", "className", "cart", "docked", "confirmation", "snackbarProps", "cartURL", "cartLinkText", "throttleClick", "disabled"]);

      return React.createElement(Fragment, null, React.createElement(Track, {
        event: "addedToCart",
        product: product
      }, React.createElement(Button, _extends({
        key: "button",
        variant: "contained",
        color: "secondary",
        size: "large",
        "data-th": "add-to-cart"
      }, other, {
        on: "tap:".concat(ampFormId, ".submit"),
        onClick: this.onClick,
        classes: {
          root: classes.root
        },
        className: classnames(className, _defineProperty({}, classes.docked, docked)),
        disabled: disabled || this.state.disabled
      }), children || 'Add to Cart')), React.createElement(Snackbar, _extends({
        key: "confirmation",
        open: this.state.messageOpen,
        autoHideDuration: 3000,
        onClose: this.handleClose,
        message: React.createElement("div", {
          className: classes.confirmation
        }, confirmation),
        action: React.createElement(React.Fragment, null, React.createElement(Link, {
          to: cartURL,
          className: classes.cartLink
        }, cartLinkText), React.createElement(IconButton, {
          key: "close",
          "aria-label": "Close",
          color: "inherit",
          className: classes.close,
          onClick: this.handleClose
        }, React.createElement(CloseIcon, null)))
      }, snackbarProps)));
    }
  }]);

  return AddToCartButton;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The product to add to the cart
   */
  product: PropTypes.object,

  /**
   * The URL for the cart page. Defaults to '/cart'.
   */
  cartURL: PropTypes.string,

  /**
   * The text for the cart link.  Defaults to "View My Cart".
   */
  cartLinkText: PropTypes.string,

  /**
   * Set to true to dock the button at the bottom of the viewport so that it is always visible
   */
  docked: PropTypes.bool,

  /**
   * A message to display when an item is added to the cart.
   * Could be a string or react component
   */
  confirmation: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),

  /**
   * Props to be applied to the Snackbar element in which the confirmation message is displayed.
   */
  snackbarProps: PropTypes.object,

  /**
   * The time in milliseconds to throttle clicking to prevent accidentally adding
   * multiple items to the cart. Specify `false` to disable throttling.
   */
  throttleClick: PropTypes.oneOfType([PropTypes.number, PropTypes.bool])
}), _defineProperty(_class2, "defaultProps", {
  docked: false,
  snackbarProps: {},
  cartURL: '/cart',
  cartLinkText: 'View My Cart',
  throttleClick: 500
}), _temp)) || _class) || _class) || _class);
export { AddToCartButton as default };
//# sourceMappingURL=AddToCartButton.js.map