import _regeneratorRuntime from "@babel/runtime/regenerator";
import "core-js/modules/es7.symbol.async-iterator";
import "core-js/modules/es6.symbol";
import "core-js/modules/web.dom.iterable";
import "regenerator-runtime/runtime";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2019 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import analytics, { configureAnalytics, activate } from './analytics';
import { Provider, inject } from 'mobx-react';
import ttiPolyfill from 'tti-polyfill';
import { getCookie } from './utils/cookie';
/**
 * Use this component to register your analytics targets.
 *
 * import AnalyticsProvider from 'react-storefront/AnalyticsProvider'
 * import GoogleAnalyticsTarget from 'react-storefront-extensions/GoogleAnalyticsTarget'
 *
 * Example:
 *
 * ```
 *  <AnalyticsProvider
 *    targets={() => [
 *      new GoogleAnalyticsTarget({
 *        trackingID: 'ABC123'
 *      })
 *    ])}
 *  >
 *    <App/>
 *  </AnalyticsProvider>
 * ```
 *
 * Components that are decendents of AnalyticsProvider can use `@inject('analytics')` to get access to
 * an object which can be used to broadcase analytics events to targets:
 *
 * ```
 *  import React, { Component } from 'react'
 *  import Button from '@material-ui/core/Button'
 *  import { inject } from 'mobx-react'
 *
 *  @inject('analytics')
 *  class MyComponent extends Component {
 *
 *    render() {
 *      return (
 *        <Button onClick={this.fireAnalyticsEvent}>Click Me</Button>
 *      )
 *    }
 *
 *    // This will call the someEvent() method on all configured analytics targets.
 *    fireAnalyticsEvent = () => {
 *      const eventData = { foo: 'bar' }
 *      this.props.analytics.fire('someEvent', eventData) // analytics prop is provided by the @inject('analytics') decorator.
 *    }
 *
 *  }
 * ```
 */

var AnalyticsProvider = (_dec = inject(function (_ref) {
  var app = _ref.app,
      history = _ref.history;
  return {
    amp: app && app.amp,
    history: history
  };
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AnalyticsProvider, _Component);

  function AnalyticsProvider(props) {
    var _this;

    _classCallCheck(this, AnalyticsProvider);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AnalyticsProvider).call(this, props)); // Configure analytics for server side AMP rendering

    if (props.targets && props.amp) {
      configureAnalytics.apply(void 0, _toConsumableArray(props.targets(false)));
    }

    return _this;
  }
  /**
   * Returns true unless a rsf_disable_analytics cookie is present and set to "true".
   * This cookie allows us to turn off analytics during smoke testing, crawling, etc...
   * @return {Boolean}
   */


  _createClass(AnalyticsProvider, [{
    key: "anayticsEnabled",
    value: function anayticsEnabled() {
      return getCookie('rsf_disable_analytics') !== 'true';
    }
  }, {
    key: "componentDidMount",
    value: function () {
      var _componentDidMount = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee() {
        var delayUntilInteractive, targets, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, target;

        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                delayUntilInteractive = this.props.delayUntilInteractive;

                if (!this.props.targets) {
                  _context.next = 32;
                  break;
                }

                if (!delayUntilInteractive) {
                  _context.next = 5;
                  break;
                }

                _context.next = 5;
                return ttiPolyfill.getFirstConsistentlyInteractive();

              case 5:
                if (!this.anayticsEnabled()) {
                  _context.next = 31;
                  break;
                }

                if (process.env.NODE_ENV === 'development') {
                  console.log('[AnalyticsProvider]', 'initializing analytics');
                }

                targets = this.props.targets();
                configureAnalytics.apply(void 0, _toConsumableArray(targets));
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context.prev = 12;

                for (_iterator = targets[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  target = _step.value;

                  if (typeof target.setHistory === 'function') {
                    target.setHistory(this.props.history);
                  }
                }

                _context.next = 20;
                break;

              case 16:
                _context.prev = 16;
                _context.t0 = _context["catch"](12);
                _didIteratorError = true;
                _iteratorError = _context.t0;

              case 20:
                _context.prev = 20;
                _context.prev = 21;

                if (!_iteratorNormalCompletion && _iterator.return != null) {
                  _iterator.return();
                }

              case 23:
                _context.prev = 23;

                if (!_didIteratorError) {
                  _context.next = 26;
                  break;
                }

                throw _iteratorError;

              case 26:
                return _context.finish(23);

              case 27:
                return _context.finish(20);

              case 28:
                activate();
                _context.next = 32;
                break;

              case 31:
                console.log('Skipping analytics because a rsf_disable_analytics=true cookie is present.');

              case 32:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[12, 16, 20, 28], [21,, 23, 27]]);
      }));

      function componentDidMount() {
        return _componentDidMount.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: "render",
    value: function render() {
      return React.createElement(Provider, {
        analytics: analytics
      }, this.props.children);
    }
  }]);

  return AnalyticsProvider;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * Function which should return desired analytics targets to configure.
   */
  targets: PropTypes.func.isRequired,

  /**
   * Set to true to delay loading of analytics until the app is interactive
   */
  delayUntilInteractive: PropTypes.bool
}), _temp)) || _class);
export { AnalyticsProvider as default };
//# sourceMappingURL=AnalyticsProvider.js.map