import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/es6.string.link";
import "core-js/modules/es6.string.fixed";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import throttle from 'lodash/throttle';
import Toolbar from '@material-ui/core/Toolbar';
import { observer, inject } from 'mobx-react';
import Hidden from '@material-ui/core/Hidden';
import withStyles from '@material-ui/core/styles/withStyles';
import ToolbarButton from './ToolbarButton';
import MenuIcon from './MenuIcon';
import AmpState from './amp/AmpState';
export var styles = function styles(theme) {
  return {
    root: {
      boxSizing: 'content-box',
      position: 'relative',
      zIndex: theme.zIndex.modal + 10
    },
    withAmp: {
      zIndex: theme.zIndex.amp.modal + 1
    },
    offline: {
      textAlign: 'center',
      backgroundColor: '#f34c4c',
      color: 'white'
    },
    toolBar: {
      height: theme.headerHeight || '64px',
      padding: "0 7px",
      maxWidth: theme.maxWidth,
      flex: 1
    },
    wrap: {
      borderBottom: "1px solid ".concat(theme.palette.divider),
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      backgroundColor: theme.palette.background.paper,
      zIndex: theme.zIndex.modal + 10,
      display: 'flex',
      justifyContent: 'center'
    },
    stuck: {
      transform: 'translateY(0)'
    },
    unstuck: {
      transform: 'translateY(-100%)'
    },
    animate: {
      transition: 'transform .15s ease-in'
    },
    hidden: {
      position: 'fixed',
      zIndex: theme.zIndex.modal + 10,
      boxShadow: theme.shadows[2],
      top: 0,
      left: 0,
      right: 0
    },
    menuOpen: {
      boxShadow: 'none'
    },
    link: {
      textDecoration: 'none'
    }
  };
};
/**
 * A header that auto hides when the user scrolls down and auto shows when the user
 * scrolls up. A hamburger button that controls the menu is automatically displayed on
 * the left side of the header.  Children are placed directly to the right of the menu
 * button.
 */

var Header = (_dec = inject(function (_ref) {
  var app = _ref.app;
  return {
    menu: app.menu,
    amp: app.amp,
    offline: app.offline
  };
}), _dec2 = withStyles(styles, {
  name: 'RSFAppBar'
}), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Header, _Component);

  function Header() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Header);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Header)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      stuck: false,
      hidden: false,
      animate: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onMenuButtonClick", function () {
      _this.props.menu.toggle();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onScroll", function () {
      var height = 64,
          _window = window,
          scrollY = _window.scrollY,
          _assertThisInitialize = _assertThisInitialized(_assertThisInitialized(_this)),
          lastScrollY = _assertThisInitialize.lastScrollY;

      var menu = _this.props.menu;

      if (_this.state.hidden) {
        if (scrollY <= 0) {
          _this.setState({
            hidden: false,
            stuck: false,
            animate: false
          });
        }
      } else {
        if (scrollY > height && !menu.open) {
          _this.setState({
            hidden: true
          });
        }
      }

      var unstickBufferZone = 15;

      if (_this.throttledScrollY > scrollY + unstickBufferZone && !_this.state.stuck) {
        _this.unstickAt = scrollY + unstickBufferZone;

        _this.setState({
          stuck: true
        });
      } else if (scrollY > _this.unstickAt && _this.state.stuck && !menu.open) {
        _this.setState({
          stuck: false
        });

        delete _this.unstickAt;
      }

      if (_this.lastScrollY > scrollY && _this.state.stuck) {
        _this.unstickAt = scrollY + unstickBufferZone;
      }

      _this.lastScrollY = scrollY;

      _this.sampleScrollSpeed();
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "sampleScrollSpeed", throttle(function () {
      return _this.throttledScrollY = window.scrollY;
    }, 100));

    return _this;
  }

  _createClass(Header, [{
    key: "render",
    value: function render() {
      var _classnames, _classnames2;

      var _this$props = this.props,
          MenuIcon = _this$props.MenuIcon,
          classes = _this$props.classes,
          children = _this$props.children,
          fixed = _this$props.fixed,
          menu = _this$props.menu,
          amp = _this$props.amp,
          menuAlign = _this$props.menuAlign,
          menuIconProps = _this$props.menuIconProps,
          offline = _this$props.offline,
          offlineWarning = _this$props.offlineWarning;
      var items = React.Children.toArray(children);
      var menuButton = React.createElement(Hidden, {
        mdUp: true,
        implementation: "css",
        key: "menuButton"
      }, React.createElement("a", {
        on: "tap:AMP.setState({ rsfMenu: { open: !rsfMenu.open, list: '@' } }), moov_menu.toggle",
        className: classes.link
      }, React.createElement(ToolbarButton, {
        "aria-label": "Menu",
        color: "inherit",
        onClick: this.onMenuButtonClick,
        icon: React.createElement(MenuIcon, _extends({
          open: menu.open
        }, menuIconProps))
      })));

      if (menuAlign === 'right') {
        items.push(menuButton);
      } else {
        items.unshift(menuButton);
      }

      return React.createElement("div", null, offline && React.createElement("div", {
        className: classes.offline
      }, offlineWarning), React.createElement("div", {
        className: classnames((_classnames = {}, _defineProperty(_classnames, classes.root, true), _defineProperty(_classnames, classes.withAmp, amp), _classnames))
      }, React.createElement("div", {
        className: classnames((_classnames2 = {}, _defineProperty(_classnames2, classes.wrap, true), _defineProperty(_classnames2, classes.fixed, fixed), _defineProperty(_classnames2, classes.hidden, this.state.hidden || menu.open), _defineProperty(_classnames2, classes.stuck, this.state.hidden && this.state.stuck || menu.open), _defineProperty(_classnames2, classes.unstuck, this.state.hidden && !this.state.stuck), _defineProperty(_classnames2, classes.animate, this.state.animate), _defineProperty(_classnames2, classes.menuOpen, menu.open), _classnames2))
      }, React.createElement(Toolbar, {
        disableGutters: true,
        classes: {
          root: classes.toolBar
        }
      }, items))));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('scroll', this.onScroll, {
        passive: true
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('scroll', this.onScroll, {
        passive: true
      });
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _this2 = this;

      if (!prevState.hidden && this.state.hidden) {
        setTimeout(function () {
          return _this2.setState({
            animate: true
          });
        }, 100);
      }
    }
  }]);

  return Header;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * CSS classes
   */
  classes: PropTypes.object,

  /**
   * A component for the menu icon.
   */
  MenuIcon: PropTypes.func,

  /**
   * Additional props for the menu icon
   */
  menuIconProps: PropTypes.object,

  /**
   * Sets the alignment of the menu icon. "right" or "left".
   */
  menuAlign: PropTypes.oneOf(['left', 'right']),

  /**
   * String or Element to render within the offline warning container at the top of the app
   */
  offlineWarning: PropTypes.oneOfType([PropTypes.string, PropTypes.element])
}), _defineProperty(_class2, "defaultProps", {
  MenuIcon: MenuIcon,
  menuIconProps: {},
  menuAlign: 'left',
  offlineWarning: 'Your device lost its internet connection.'
}), _temp)) || _class) || _class) || _class);
export { Header as default };
//# sourceMappingURL=AppBar.js.map