import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import get from 'lodash/get';
import ArrowLeft from '@material-ui/icons/KeyboardArrowLeft';
import ListViewIcon from '@material-ui/icons/ViewAgenda';
import GridViewIcon from '@material-ui/icons/BorderAll';
import withStyles from '@material-ui/core/styles/withStyles';
import Typography from '@material-ui/core/Typography';
import { inject, observer } from 'mobx-react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { LAYOUT_LIST, LAYOUT_GRID } from './model/SearchResultsModelBase';
import Paper from '@material-ui/core/Paper';
/**
 * A header that allows the user to navigate back.  When a searchResults prop is provided,
 * this component also allows the user to switch between grid and list views.
 */

export var styles = function styles(theme) {
  return {
    root: {
      padding: '6px 86px',
      position: 'relative',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      borderTop: "1px solid ".concat(theme.palette.divider),
      zIndex: theme.zIndex.appBar - 1,
      '& a': {
        color: theme.palette.text.primary,
        textDecoration: 'none'
      }
    },
    label: {
      fontWeight: 'bold',
      fontSize: '18px',
      display: 'block',
      textAlign: 'center',
      textTransform: 'uppercase',
      padding: 0
    },
    backButtonWrapper: {
      position: 'absolute',
      top: 0,
      left: '5px',
      height: '41px',
      display: 'flex',
      alignItems: 'center'
    },
    switchButtonsWrapper: {
      position: 'absolute',
      display: 'flex',
      alignItems: 'center',
      top: 0,
      right: '10px',
      height: '41px'
    },
    switchButton: {
      marginLeft: '5px',
      alignItems: 'center',
      display: 'flex',
      padding: '3px',
      borderRadius: '50%'
    },
    selectedSwitchButton: {
      backgroundColor: '#F4F2F1'
    }
  };
};
var BackNav = (_dec = withStyles(styles, {
  name: 'RSFBackNav'
}), _dec2 = inject('history'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(BackNav, _Component);

  function BackNav() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, BackNav);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(BackNav)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "switchLayout", function (layout) {
      var searchResults = _this.props.searchResults;
      searchResults.switchLayout(layout);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onBack", function () {
      var _this$props = _this.props,
          history = _this$props.history,
          url = _this$props.url;

      if (url) {
        history.push(url);
      } else {
        history.goBack();
      }
    });

    return _this;
  }

  _createClass(BackNav, [{
    key: "renderViewToggle",
    value: function renderViewToggle() {
      var _this2 = this;

      var _this$props2 = this.props,
          classes = _this$props2.classes,
          searchResults = _this$props2.searchResults;
      var layout = get(searchResults, 'layout', LAYOUT_GRID);
      return searchResults ? React.createElement("span", {
        className: classes.switchButtonsWrapper
      }, React.createElement("span", {
        className: classnames(classes.switchButton, _defineProperty({}, classes.selectedSwitchButton, layout === LAYOUT_GRID))
      }, React.createElement(GridViewIcon, {
        color: layout === LAYOUT_GRID ? 'secondary' : 'primary',
        onClick: function onClick() {
          return _this2.switchLayout(LAYOUT_GRID);
        }
      })), React.createElement("span", {
        className: classnames(classes.switchButton, _defineProperty({}, classes.selectedSwitchButton, layout === LAYOUT_LIST))
      }, React.createElement(ListViewIcon, {
        color: layout === LAYOUT_LIST ? 'secondary' : 'primary',
        onClick: function onClick() {
          return _this2.switchLayout(LAYOUT_LIST);
        }
      }))) : null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props3 = this.props,
          text = _this$props3.text,
          classes = _this$props3.classes,
          labelComponent = _this$props3.labelComponent;
      return React.createElement(Paper, {
        className: classes.root
      }, React.createElement(Typography, {
        variant: "caption"
      }, React.createElement("span", {
        onClick: function onClick() {
          _this3.onBack();
        },
        className: classes.backButtonWrapper
      }, React.createElement(ArrowLeft, null)), React.createElement(labelComponent, {
        className: classes.label
      }, text), this.renderViewToggle()));
    }
  }]);

  return BackNav;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The text to display representing the previous location.
   */
  text: PropTypes.string.isRequired,

  /**
   * The url to navigate to when clicked.  If omitted, this component will navigate back in the history when clicked.
   */
  url: PropTypes.string,

  /**
   * When displaying this component on a search results page (such as a subcategory), you can supply the SearchResultsModelBase instance here
   * and this component will allow you to switch between grid and list views.
   */
  searchResults: PropTypes.shape({
    layout: PropTypes.string.isRequired
  }),

  /**
   * Overrides the default HTML element used for the label (span).
   */
  labelComponent: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  labelComponent: 'span'
}), _temp)) || _class) || _class) || _class);
export { BackNav as default };
//# sourceMappingURL=BackNav.js.map