import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2019 Moov Corporation.  All rights reserved.
 */
import React, { Component, createRef } from 'react';
import PropTypes from 'prop-types';
import throttle from 'lodash/throttle';
import ArrowUpward from '@material-ui/icons/ArrowUpward';
import Fab from '@material-ui/core/Fab';
import Fade from '@material-ui/core/Fade';
import { withStyles } from '@material-ui/core/styles';

var styles = function styles() {
  return {
    root: {
      zIndex: 1,
      position: 'fixed',
      bottom: 24,
      right: 16
    },
    fab: {
      background: 'rgba(0,0,0,.85)',
      '&:hover': {
        background: 'rgb(0,0,0)'
      }
    },
    icon: {
      color: 'white'
    }
  };
};
/**
 * Customizable component which scrolls to top of the page
 */


var BackToTop = (_dec = withStyles(styles, {
  name: 'RSFBackToTop'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(BackToTop, _Component);

  function BackToTop(props) {
    var _this;

    _classCallCheck(this, BackToTop);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BackToTop).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      visible: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onScroll", throttle(function () {
      _this.setState({
        visible: _this.scrollY > _this.props.showUnderY && _this.el.current.parentElement && _this.el.current.parentElement.offsetParent != null
      });
    }, 200));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "scrollToTop", function () {
      var behavior = _this.scrollY > _this.props.instantBehaviorUnderY ? 'auto' : 'smooth';
      window.scrollTo({
        top: 0,
        left: 0,
        behavior: behavior
      });
    });

    _this.el = createRef();
    return _this;
  }

  _createClass(BackToTop, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.onScroll();
      window.addEventListener('scroll', this.onScroll, {
        passive: true
      });
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('scroll', this.onScroll);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          fadeTime = _this$props.fadeTime,
          size = _this$props.size;
      var visible = this.state.visible;
      var Icon = this.props.Icon || ArrowUpward;
      return React.createElement("div", {
        className: classes.root,
        ref: this.el
      }, React.createElement(Fade, {
        in: visible,
        timeout: fadeTime
      }, React.createElement(Fab, {
        className: classes.fab,
        size: size,
        onClick: this.scrollToTop,
        title: "back to top"
      }, React.createElement(Icon, {
        className: classes.icon
      }))));
    }
  }, {
    key: "scrollY",
    get: function get() {
      return window.scrollY || window.pageYOffset;
    }
  }]);

  return BackToTop;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The icon to use within Fab component
   */
  Icon: PropTypes.func,

  /**
   * value which controls where along the Y position the BackToTop component is shown
   */
  showUnderY: PropTypes.number,

  /**
   * When the scroll position is less than this value, the page will smoothly scroll back up. If
   * the scroll position is more than this value, the page will immediately scroll back up.
   */
  instantBehaviorUnderY: PropTypes.number,

  /**
   * Fade in/out animation time of icon
   */
  fadeTime: PropTypes.number,

  /**
   * Controls size of component. Values allowed are [small, medium, large]
   */
  size: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  showUnderY: 250,
  instantBehaviorUnderY: 3000,
  fadeTime: 320,
  size: 'medium'
}), _temp)) || _class);
export { BackToTop as default };
//# sourceMappingURL=BackToTop.js.map