import "core-js/modules/es6.regexp.split";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import withStyles from '@material-ui/core/styles/withStyles';
import classnames from 'classnames';
import PropTypes from 'prop-types';
/**
 * A flex container.  All additional props are spread to the style of the underlying div.
 */

export var styles = function styles(theme) {
  return {
    root: {
      display: 'flex'
    },
    split: {
      justifyContent: 'space-between',
      alignItems: 'center'
    }
  };
};
var Box = (_dec = withStyles(styles, {
  name: 'RSFBox'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Box, _Component);

  function Box() {
    _classCallCheck(this, Box);

    return _possibleConstructorReturn(this, _getPrototypeOf(Box).apply(this, arguments));
  }

  _createClass(Box, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          classes = _this$props.classes,
          _this$props$split = _this$props.split,
          split = _this$props$split === void 0 ? false : _this$props$split,
          children = _this$props.children,
          style = _this$props.style,
          other = _objectWithoutProperties(_this$props, ["className", "classes", "split", "children", "style"]);

      return React.createElement("div", {
        className: classnames(classes.root, className, _defineProperty({}, classes.split, split)),
        style: _objectSpread({}, other, style)
      }, children);
    }
  }]);

  return Box;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * CSS classes to apply
   */
  classes: PropTypes.object,

  /**
   * True to split items on opposite sides of the box by applying justify-content: 'space-between'
   */
  split: PropTypes.bool
}), _temp)) || _class);
export { Box as default };
/**
 * A flex container with horizontal layout. All additional props are spread to the style
 * of the underlying div.
 */

export function Hbox(props) {
  props = _objectSpread({}, props, {
    flexDirection: 'row'
  });
  return React.createElement(Box, _extends({
    alignItems: "center"
  }, props));
}
Hbox.propTypes = {
  /**
   * CSS classes to apply
   */
  classes: PropTypes.object,

  /**
   * True to split items on opposite sides of the box by applying justify-content: 'space-between'
   */
  split: PropTypes.bool
  /**
   * A flex container with vertical layout. All additional props are spread to
   * the style of the underlying div.
   */

};
export function Vbox(props) {
  props = _objectSpread({}, props, {
    flexDirection: 'column'
  });
  return React.createElement(Box, props);
}
Vbox.propTypes = {
  /**
   * CSS classes to apply
   */
  classes: PropTypes.object,

  /**
   * True to split items on opposite sides of the box by applying justify-content: 'space-between'
   */
  split: PropTypes.bool
};
//# sourceMappingURL=Box.js.map