import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import ArrowRight from '@material-ui/icons/KeyboardArrowRight';
import Link from './Link';
import withStyles from '@material-ui/core/styles/withStyles';
import Typography from '@material-ui/core/Typography';
import { inject, observer } from 'mobx-react';
import Track from './Track';
import Container from './Container';
import PropTypes from 'prop-types';
export var styles = function styles(theme) {
  return {
    breadcrumbs: {
      margin: '0',
      backgroundColor: '#F4F2F1',
      padding: '12px 0',
      '& a': {
        color: theme.palette.text.primary,
        textDecoration: 'none'
      }
    },
    separator: {
      height: '12px',
      position: 'relative',
      top: '2px',
      width: '16px'
    },
    current: {
      fontWeight: 'bold',
      color: theme.palette.text.primary
    }
  };
};
/**
 * Renders a list of breadcrumbs from AppModelBase.breadcrumbs.  When a breadcrumb is clicked, the breadcrumb_clicked
 * analytics event is automatically fired.
 */

var Breadcrumbs = (_dec = withStyles(styles, {
  name: 'RSFBreadcrumbs'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Breadcrumbs, _Component);

  function Breadcrumbs() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Breadcrumbs);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Breadcrumbs)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderBreadcrumb", function (item, i) {
      var classes = _this.props.classes;
      var arrow = i > 0 ? React.createElement(ArrowRight, {
        className: classes.separator
      }) : null;

      if (item.url) {
        var eventData = item.toJSON ? item.toJSON() : item;
        return React.createElement("span", {
          key: i
        }, arrow, React.createElement(Track, {
          event: "breadcrumbClicked",
          breadcrumb: eventData
        }, React.createElement(Link, {
          to: item.url,
          state: item.state
        }, item.text)));
      } else {
        return React.createElement("span", {
          key: i,
          className: classes.current
        }, arrow, item.text);
      }
    });

    return _this;
  }

  _createClass(Breadcrumbs, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          breadcrumbs = _this$props.app.breadcrumbs,
          items = _this$props.items,
          hideLast = _this$props.hideLast,
          classes = _this$props.classes;
      breadcrumbs = items || breadcrumbs;

      if (hideLast) {
        breadcrumbs = breadcrumbs.slice(0, breadcrumbs.length - 1);
      }

      return React.createElement(Typography, {
        className: classes.breadcrumbs,
        variant: "caption"
      }, React.createElement(Container, null, breadcrumbs && breadcrumbs.map(this.renderBreadcrumb), React.createElement("span", null, "\xA0")));
    }
  }]);

  return Breadcrumbs;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The items to display, each with url, text, and state.
   */
  items: PropTypes.arrayOf(PropTypes.objectOf),

  /**
   * Set to true to hide the last breadcrumb
   */
  hideLast: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  hideLast: false
}), _temp)) || _class) || _class) || _class);
export { Breadcrumbs as default };
//# sourceMappingURL=Breadcrumbs.js.map