import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import "core-js/modules/es6.regexp.match";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import Button from '@material-ui/core/Button';
import PropTypes from 'prop-types';
import { withStyles } from '@material-ui/core/';
import { inject } from 'mobx-react';
import classnames from 'classnames';
/**
 * A button that links to Checkout, to be displayed on the Cart page.  The style matches
 * AddToCartButton by default.
 */

export var styles = function styles(theme) {
  return {
    root: {
      fontSize: theme.typography.subheading.fontSize,
      padding: "".concat(theme.margins.container, "px")
    },
    docked: {
      position: 'fixed',
      left: 0,
      bottom: 0,
      width: '100%',
      zIndex: 1,
      borderRadius: '0'
    }
  };
};
var CheckoutButton = (_dec = withStyles(styles, {
  name: 'RSFCheckoutButton'
}), _dec2 = inject('history'), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(CheckoutButton, _Component);

  function CheckoutButton() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, CheckoutButton);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(CheckoutButton)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function () {
      var _this$props = _this.props,
          history = _this$props.history,
          url = _this$props.url;

      if (url.match(/^(https?:)?\/\//)) {
        window.location.href = url;
      } else {
        history.push(url);
      }
    });

    return _this;
  }

  _createClass(CheckoutButton, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          classes = _this$props2.classes,
          className = _this$props2.className,
          url = _this$props2.url,
          children = _this$props2.children,
          docked = _this$props2.docked,
          others = _objectWithoutProperties(_this$props2, ["classes", "className", "url", "children", "docked"]);

      return React.createElement(Button, _extends({
        size: "large",
        color: "secondary",
        onClick: this.onClick,
        variant: "contained",
        "data-th": "checkout-link"
      }, others, {
        classes: {
          root: classes.root
        },
        className: classnames(className, _defineProperty({}, classes.docked, docked))
      }), children || 'Checkout');
    }
  }]);

  return CheckoutButton;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The URL for checkout.  Defaults to "/checkout"
   */
  url: PropTypes.string,

  /**
   * Set to true to dock the button at the bottom of the viewport so that it is always visible
   */
  docked: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  url: '/checkout',
  docked: false
}), _temp)) || _class) || _class);
export { CheckoutButton as default };
//# sourceMappingURL=CheckoutButton.js.map