import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/es6.string.anchor";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import ResizeObserver from 'resize-observer-polyfill';
import MUIDrawer from '@material-ui/core/Drawer';
import { withStyles } from '@material-ui/core/styles';
import Close from '@material-ui/icons/Close';
import Fab from '@material-ui/core/Fab';
import PropTypes from 'prop-types';
import Typography from '@material-ui/core/Typography';
import { inject } from 'mobx-react';
import classnames from 'classnames';
/**
 * A slide-in drawer with fab close button.
 */

export var styles = function styles(theme) {
  return {
    root: {
      zIndex: theme.zIndex.modal + 10
    },
    closeButton: {
      position: 'absolute',
      right: '10px',
      top: '-28px',
      zIndex: 1
    },
    container: {
      height: '100%',
      boxSizing: 'border-box',
      flexWrap: 'nowrap',
      display: 'flex',
      flexDirection: 'column'
    },
    content: {
      flexBasis: '100%',
      overflow: 'auto'
    },
    paper: {
      overflowY: 'visible'
    },
    title: {
      flexBasis: 'auto',
      flexGrow: 0,
      flexShrink: 1,
      width: '100%',
      height: '72px',
      lineHeight: '72px',
      textAlign: 'center',
      borderBottom: "1px solid ".concat(theme.palette.divider)
    },
    ampClosed: {
      display: 'none'
    }
  };
};
var Drawer = (_dec = withStyles(styles, {
  name: 'RSFDrawer'
}), _dec2 = inject(function (_ref) {
  var app = _ref.app,
      ampStateId = _ref.ampStateId;
  return {
    amp: app && app.amp,
    ampStateId: ampStateId
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Drawer, _Component);

  function Drawer() {
    var _this;

    _classCallCheck(this, Drawer);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Drawer).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "closeDrawer", function () {
      var onRequestClose = _this.props.onRequestClose;
      onRequestClose();
      document.body.style.paddingBottom = 0;
    });

    _this.drawer = React.createRef();
    return _this;
  }

  _createClass(Drawer, [{
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props = this.props,
          amp = _this$props.amp,
          ampStateId = _this$props.ampStateId,
          ampBindClosed = _this$props.ampBindClosed,
          variant = _this$props.variant,
          closeButtonProps = _this$props.closeButtonProps,
          showCloseButton = _this$props.showCloseButton,
          open = _this$props.open,
          onRequestClose = _this$props.onRequestClose,
          title = _this$props.title,
          children = _this$props.children,
          classes = _this$props.classes,
          autoAdjustBodyPadding = _this$props.autoAdjustBodyPadding,
          anchor = _this$props.anchor,
          rest = _objectWithoutProperties(_this$props, ["amp", "ampStateId", "ampBindClosed", "variant", "closeButtonProps", "showCloseButton", "open", "onRequestClose", "title", "children", "classes", "autoAdjustBodyPadding", "anchor"]);

      return React.createElement(MUIDrawer, _extends({
        anchor: anchor,
        classes: {
          root: classes.root,
          paper: classnames((_classnames = {}, _defineProperty(_classnames, classes.paper, true), _defineProperty(_classnames, classes.ampClosed, amp && !open), _classnames))
        },
        "amp-bind": ampBindClosed ? "class=>".concat(ampStateId, ".").concat(ampBindClosed, " ? '").concat(classes.ampClosed, "' : null") : null,
        open: amp && variant === 'temporary' || open,
        variant: variant,
        onClose: onRequestClose && onRequestClose
      }, rest), React.createElement("div", {
        className: classes.container,
        ref: this.drawer
      }, title && React.createElement(Typography, {
        className: classes.title,
        variant: "h6",
        component: "div"
      }, title), showCloseButton && anchor === 'bottom' && React.createElement(Fab, _extends({
        color: "primary",
        className: classes.closeButton,
        onClick: this.closeDrawer,
        style: {
          display: open ? '' : 'none'
        },
        on: ampBindClosed ? "tap:AMP.setState({ ".concat(ampStateId, ": { ").concat(ampBindClosed, ": true }})") : null
      }, closeButtonProps), React.createElement(Close, null)), React.createElement("div", {
        className: classes.content
      }, children)));
    } // add body padding equal to drawer height

  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.setPadding();
      var el = this.drawer.current;

      if (this.props.autoAdjustBodyPadding && el) {
        this.drawerResize = new ResizeObserver(function () {
          document.body.style.paddingBottom = el && el.clientHeight + 'px';
        });
        this.drawerResize.observe(el);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var el = this.drawer.current;

      if (this.drawerResize && el) {
        this.drawerResize.unobserve(el);
      }
    } // if value of open property changes, recalcuate drawer height/body padding

  }, {
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.open && !this.props.open) {
        this.setPadding();
      } else if (this.props.open && !nextProps.open) {
        this.closeDrawer();
      }
    }
  }, {
    key: "setPadding",
    value: function setPadding() {
      var _this2 = this;

      if (this.props.autoAdjustBodyPadding) {
        requestAnimationFrame(function () {
          var el = _this2.drawer.current;
          document.body.style.paddingBottom = el && el.clientHeight + 'px';
        });
      }
    }
  }]);

  return Drawer;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * Set to false to hide the close button. Defaults to true
   */
  showCloseButton: PropTypes.bool,

  /**
   * Called when the user closes the drawer
   */
  onRequestClose: PropTypes.func.isRequired,

  /**
   * The title to display at the top of the drawer
   */
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),

  /**
   * Set to true to automatically add padding to the body when the drawer
   * is open so that the user is able to scroll and see all of the body content.
   * Defaults to false.
   */
  autoAdjustBodyPadding: PropTypes.bool,

  /**
   * Props to apply to the closeButton
   */
  closeButtonProps: PropTypes.object,

  /**
   * The name of a property the amp-state to bind to the closed state of the drawer.
   */
  ampBindClosed: PropTypes.string,

  /**
   * Side from which the drawer will appear (top, left, right, bottom). Defaults to 'bottom'
   */
  anchor: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  showCloseButton: true,
  autoAdjustBodyPadding: false,
  closeButtonProps: {},
  variant: 'temporary',
  anchor: 'bottom'
}), _temp)) || _class) || _class);
export { Drawer as default };
//# sourceMappingURL=Drawer.js.map