import "core-js/modules/es6.function.name";
import "core-js/modules/es7.symbol.async-iterator";
import "core-js/modules/es6.symbol";
import "core-js/modules/web.dom.iterable";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _objectSpread from "@babel/runtime/helpers/objectSpread";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import withStyles from '@material-ui/core/styles/withStyles';
import get from 'lodash/get';
import { observer, inject } from 'mobx-react';
import ExpandableSection from './ExpandableSection';
import Checkbox from '@material-ui/core/Checkbox';
import LoadMask from './LoadMask';
import FormGroup from '@material-ui/core/FormGroup';
import FormControlLabel from '@material-ui/core/FormControlLabel';
import Button from '@material-ui/core/Button';
import Typography from '@material-ui/core/Typography';
import PropTypes from 'prop-types';
import { Hbox } from './Box';
/**
 * UI for filtering an instance of SearchResultModelBase.  This component can be used on its own, or you can use
 * FilterButton to automatically display this component in a drawer that slides up from the bottom of the viewport.
 */

export var styles = function styles(theme) {
  return {
    root: {
      height: '100%',
      display: 'flex',
      flexDirection: 'column',
      alignItems: 'stretch'
    },
    facetGroups: {
      overflow: 'auto',
      overflowX: 'hidden',
      flex: '1',
      position: 'relative'
    },
    matches: {
      marginLeft: '5px',
      display: 'inline'
    },
    footer: {
      backgroundColor: theme.palette.secondary.main,
      padding: '12px 20px',
      color: 'white',
      justifyContent: 'space-between',
      alignItems: 'center'
    },
    itemsFound: {
      color: theme.palette.secondary.contrastText
    },
    title: _objectSpread({}, theme.typography.subtitle1, {
      marginBottom: "12px"
    }),
    noMargins: {
      margin: 0
    },
    groupLabel: {
      display: 'flex',
      alignItems: 'center'
    }
  };
};
var Filter = (_dec = withStyles(styles, {
  name: 'RSFFilter'
}), _dec2 = inject('router'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Filter, _Component);

  function Filter(props) {
    var _this;

    _classCallCheck(this, Filter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Filter).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onToggleFilter", function (facet) {
      _this.props.model.toggleFilter(facet);

      if (_this.props.refreshOnChange) {
        _this.refresh();
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onViewResultsClick", function (e) {
      _this.props.onViewResultsClick(e);

      if (!e.isDefaultPrevented()) {
        _this.refresh();
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "createExpandAllState", function () {
      var state = {};
      var model = _this.props.model;

      if (model) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = model.facetGroups[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var group = _step.value;
            state[group.name] = true;
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
      }

      return state;
    });

    _this.state = {
      expanded: props.expandAll ? _this.createExpandAllState() : {}
    };
    return _this;
  }

  _createClass(Filter, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          model = _this$props.model,
          classes = _this$props.classes,
          title = _this$props.title;
      return React.createElement("div", {
        className: classes.root
      }, title ? React.createElement("div", {
        className: classes.title
      }, title) : null, React.createElement("div", {
        className: classes.facetGroups
      }, React.createElement(LoadMask, {
        show: model.loading,
        transparent: true,
        align: "top"
      }), get(model, 'facetGroups', []).map(function (facetGroup, i) {
        return _this2.renderFacetGroup(facetGroup, i);
      })), model.filtersChanged && React.createElement(Hbox, {
        className: classes.footer,
        split: true
      }, React.createElement(Typography, {
        variant: "subtitle1",
        className: classes.itemsFound
      }, model.filters.length || 'No', " filter", model.filters.length === 1 ? '' : 's', " selected"), React.createElement(Button, {
        variant: "contained",
        size: "large",
        color: "default",
        onClick: this.onViewResultsClick
      }, "View Results")));
    }
  }, {
    key: "renderFacetGroup",
    value: function renderFacetGroup(group, key) {
      var _this3 = this;

      var _this$props2 = this.props,
          model = _this$props2.model,
          classes = _this$props2.classes,
          margins = _this$props2.margins;
      var expanded = this.state.expanded;
      var selection = [];
      var formGroup = React.createElement(FormGroup, {
        key: key
      }, group.facets.map(function (facet, i) {
        var checked = false;

        if (get(model, 'filters', []).indexOf(facet.code) !== -1) {
          selection.push(facet);
          checked = true;
        }

        return React.createElement(FormControlLabel, {
          key: i,
          label: React.createElement("div", {
            className: classes.groupLabel
          }, React.createElement("span", null, facet.name), React.createElement(Typography, {
            variant: "caption",
            className: classes.matches,
            component: "span"
          }, "(", facet.matches, ")")),
          control: React.createElement(Checkbox, {
            checked: checked,
            color: "primary",
            onChange: _this3.onToggleFilter.bind(_this3, facet)
          })
        });
      }));
      var caption = null;

      if (selection.length === 1) {
        caption = selection[0].name;
      } else if (selection.length > 0) {
        caption = "".concat(selection.length, " selected");
      }

      return React.createElement(ExpandableSection, {
        key: key,
        title: group.name,
        caption: caption,
        expanded: expanded[group.name],
        onChange: function onChange(e, expanded) {
          return _this3.setState({
            expanded: _objectSpread({}, _this3.state.expanded, _defineProperty({}, group.name, expanded))
          });
        },
        margins: margins
      }, expanded[group.name] && formGroup);
    }
  }, {
    key: "refresh",
    value: function refresh() {
      var _this$props3 = this.props,
          router = _this$props3.router,
          model = _this$props3.model;
      router.applySearch(_defineProperty({}, this.props.queryParam, model.filters.toJSON()));
      model.refresh();
    }
  }]);

  return Filter;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * An instance of `SearchResultModelBase`
   */
  model: PropTypes.object,

  /**
   * CSS classes
   */
  classes: PropTypes.object,

  /**
   * A function to call when the user clicks the button to view updated results.  The default behavior can be
   * canceled by calling `preventDefault` on the passed in event.  The event is passed as the only argument.
   */
  onViewResultsClick: PropTypes.func,

  /**
   * The query string parameter that should be updated when filters are changed.  The value will be an array
   * of codes for each selected facet.  Defaults to "filters"
   */
  queryParam: PropTypes.string,

  /**
   * An optional title to display at the top of the component.
   */
  title: PropTypes.string,

  /**
   * Set to false to remove the default left and right margins. Defaults to `true`.
   */
  margins: PropTypes.bool,

  /**
   * Set to `true` to expand all groups on initial render
   */
  expandAll: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  onViewResultsClick: Function.prototype,
  queryParam: 'filters',
  margins: true
}), _temp)) || _class) || _class) || _class);
export { Filter as default };
//# sourceMappingURL=Filter.js.map