import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import CircularProgress from '@material-ui/core/CircularProgress';
import { withStyles } from '@material-ui/core/styles';
import classnames from 'classnames';
import PropTypes from 'prop-types';
export var styles = function styles(theme) {
  return {
    root: {
      position: 'absolute',
      top: 0,
      left: 0,
      right: 0,
      bottom: 0,
      display: 'none',
      justifyContent: 'center',
      alignItems: 'center',
      background: theme.palette.background.default,
      zIndex: 1
    },
    fullscreen: {
      height: "calc(100vh - ".concat(theme.headerHeight, "px)"),
      bottom: 'initial',
      zIndex: theme.zIndex.appBar - 10,
      'body.moov-amp &': {
        position: 'fixed',
        marginTop: 0,
        opacity: 0.8
      }
    },
    transparent: {
      backgroundColor: 'rgba(255,255,255,0.5)'
    },
    alignTop: {
      alignItems: 'flex-start',
      paddingTop: '200px'
    },
    show: {
      display: 'flex'
    }
  };
};
/**
 * The load mask displays when fetching data from the server.
 */

var LoadMask = (_dec = withStyles(styles, {
  name: 'RSFLoadMask'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(LoadMask, _Component);

  function LoadMask() {
    _classCallCheck(this, LoadMask);

    return _possibleConstructorReturn(this, _getPrototypeOf(LoadMask).apply(this, arguments));
  }

  _createClass(LoadMask, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      this.toggleOverflow();
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.toggleOverflow();
    }
  }, {
    key: "toggleOverflow",
    value: function toggleOverflow() {
      if (this.props.fullscreen) {
        if (this.props.show) {
          document.body.style.overflow = 'hidden';
        } else {
          document.body.style.overflow = 'visible';
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _classnames;

      var _this$props = this.props,
          classes = _this$props.classes,
          show = _this$props.show,
          style = _this$props.style,
          className = _this$props.className,
          children = _this$props.children,
          fullscreen = _this$props.fullscreen,
          transparent = _this$props.transparent,
          align = _this$props.align;
      return React.createElement("div", {
        style: style,
        className: classnames(classes.root, className, (_classnames = {}, _defineProperty(_classnames, classes.show, show), _defineProperty(_classnames, classes.fullscreen, fullscreen), _defineProperty(_classnames, classes.transparent, transparent), _defineProperty(_classnames, classes.alignTop, align === 'top'), _classnames))
      }, children || React.createElement(CircularProgress, {
        className: classes.progress,
        color: "secondary"
      }));
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.body.style.overflow = 'visible';
    }
  }]);

  return LoadMask;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * Set to true to display the load mask, otherwise it will be hidden.
   * Defaults to false.
   */
  show: PropTypes.bool,

  /**
   * Set to true to toggle the overflow style on the body when showing.
   * Defaults to false
   */
  fullscreen: PropTypes.bool,

  /**
   * Set to true to show the partially show the background through the load mask
   */
  transparent: PropTypes.bool,

  /**
   * Set to top to show the spinner near the top. Defaults to 'center'
   */
  align: PropTypes.oneOf(['center', 'top'])
}), _defineProperty(_class2, "defaultProps", {
  show: false,
  fullscreen: false,
  align: 'center'
}), _temp)) || _class);
export { LoadMask as default };
//# sourceMappingURL=LoadMask.js.map