import "core-js/modules/es6.regexp.replace";
import "core-js/modules/es6.regexp.search";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { inject, observer, Provider } from 'mobx-react';
import { Helmet } from 'react-helmet';
import withStyles from '@material-ui/core/styles/withStyles';
import CssBaseline from '@material-ui/core/CssBaseline';
import { canUseClientSideNavigation } from './utils/url';
import delegate from 'delegate';
import { cache } from './router/serviceWorker';
import { isSafari } from './utils/browser';
import { connectReduxDevtools } from 'mst-middlewares';
import AppContext from './AppContext';
import ErrorBoundary from './ErrorBoundary';
/**
 * @private
 * Internal PWA root used when launching the app.  Do not use this class directly
 */

export var styles = function styles(theme) {
  return {
    '@global': {
      html: {
        touchAction: 'manipulation'
      },
      'body.moov-modal': {
        overflow: 'hidden',
        position: 'fixed',
        maxWidth: '100vw',
        maxHeight: '100vh'
      },
      'body.moov-blur #root': {
        filter: 'blur(5px)',
        transition: "filter ".concat(theme.transitions.duration.enteringScreen, "ms")
      }
    }
  };
};
var PWA = (_dec = withStyles(styles), _dec2 = inject(function (_ref) {
  var app = _ref.app,
      history = _ref.history,
      router = _ref.router;
  return {
    app: app,
    history: history,
    router: router,
    amp: app.amp
  };
}), _dec(_class = _dec2(_class = observer(_class = (_temp =
/*#__PURE__*/
function (_Component) {
  _inherits(PWA, _Component);

  function PWA(_ref2) {
    var _this;

    var app = _ref2.app,
        history = _ref2.history,
        router = _ref2.router,
        errorReporter = _ref2.errorReporter;

    _classCallCheck(this, PWA);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PWA).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_nextId", 0);

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "nextId", function () {
      return _this._nextId++;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onBeforeRouteChange", function (_ref3) {
      var action = _ref3.action;

      // We'll check this to determine if the page should be reset after the next render
      // this ensures that the scroll reset doesn't happen until the new page is rendered.
      // Otherwise we would see the current page scroll to the top and after some delay, the new
      // page would render
      if (action === 'PUSH') {
        _this.props.app.setScrollResetPending(true);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "resetPage", function () {
      window.scrollTo(0, 0);

      _this.props.app.menu.close();
    });

    _this.recordStateOnChange(history);

    _this.appContextValue = {
      app: app,
      history: history,
      router: router,
      errorReporter: errorReporter
    };
    return _this;
  }

  _createClass(PWA, [{
    key: "recordStateOnChange",
    value: function recordStateOnChange(history) {
      var _this2 = this;

      var _arr = ['push', 'go', 'goBack', 'goForward'];

      var _loop = function _loop() {
        var method = _arr[_i];
        var original = history[method];

        history[method] = function () {
          _this2.recordState();

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          original.call.apply(original, [history].concat(args));
        };
      };

      for (var _i = 0; _i < _arr.length; _i++) {
        _loop();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          amp = _this$props.amp,
          app = _this$props.app,
          errorReporter = _this$props.errorReporter; // This line is needed to ensure that the app rerenders and scrolls to the top when the URL changes
      // Note that we should *not* read app.scrollResetPending here, as it will cause the app to scroll
      // to the top before the page is rerendered

      var uri = app.uri;
      return React.createElement(AppContext.Provider, {
        value: this.appContextValue
      }, React.createElement(Provider, {
        nextId: this.nextId,
        errorReporter: errorReporter
      }, React.createElement(ErrorBoundary, {
        onError: errorReporter
      }, React.createElement(Fragment, null, React.createElement(CssBaseline, null), React.createElement(Helmet, null, React.createElement("html", {
        lang: "en"
      }), React.createElement("meta", {
        charset: "utf-8"
      }), React.createElement("meta", {
        name: "viewport",
        content: "width=device-width"
      }), React.createElement("meta", {
        name: "theme-color",
        content: "#000000"
      }), app.description ? React.createElement("meta", {
        name: "description",
        content: app.description
      }) : null, app.canonicalURL ? React.createElement("link", {
        rel: "canonical",
        href: app.canonicalURL
      }) : null, React.createElement("link", {
        rel: "manifest",
        href: "/manifest.json",
        crossorigin: "use-credentials"
      }), app.title ? React.createElement("title", null, app.title) : null), amp && React.createElement(Helmet, null, React.createElement("script", {
        async: true,
        src: "https://cdn.ampproject.org/v0.js"
      }), React.createElement("script", {
        async: true,
        "custom-element": "amp-install-serviceworker",
        src: "https://cdn.ampproject.org/v0/amp-install-serviceworker-0.1.js"
      })), amp && React.createElement("amp-install-serviceworker", {
        src: "".concat(app.location.urlBase, "/service-worker.js"),
        "data-iframe-src": "".concat(app.location.urlBase, "/pwa/install-service-worker.html"),
        layout: "nodisplay"
      }), this.props.children))));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props2 = this.props,
          router = _this$props2.router,
          app = _this$props2.app,
          history = _this$props2.history;

      if (router) {
        router.watch(history, app.applyState);
        router.on('before', this.onBeforeRouteChange);
      } // scroll to the top and close the when the router runs a PWA route


      this.watchLinkClicks(); // put os class on body for platform-specific styling

      this.addDeviceClassesToBody(); // set initial offline status

      app.setOffline(!navigator.onLine);
      window.addEventListener('online', function () {
        app.setOffline(false); // Fetch fresh page data since offline version may not be correct

        if (router) {
          router.fetchFreshState(document.location).then(app.applyState);
        }
      });
      window.addEventListener('offline', function () {
        app.setOffline(true);
      }); // Fetching new app state for offline page

      if (!navigator.onLine && app.page === null) {
        router.fetchFreshState(document.location).then(function (state) {
          state.offline = true;
          app.applyState(state);
        });
      } // only cache app shell and page if online


      if (navigator.onLine) {
        // cache the app shell so that we can load pages when offline when we don't have a cached SSR response
        if (router && router.isAppShellConfigured()) {
          cache('/.app-shell');
        } // cache the initial page HTML and json


        var path = app.location.pathname + app.location.search;
        cache(path + '.json', window.initialRouteData);
        cache(path, "<!DOCTYPE html>\n".concat(document.documentElement.outerHTML));
      }

      if (process.env.NODE_ENV !== 'production' && process.env.NODE_ENV !== 'test') {
        connectReduxDevtools(require('remotedev'), app);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate() {
      var app = this.props.app;

      if (app.scrollResetPending) {
        this.resetPage();
        app.setScrollResetPending(false);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.props.router) {
        this.props.router.removeListener('before', this.onBeforeRouteChange);
      }
    }
    /**
     * Records the app state in the history state.
     * This makes restoring the page when going back really fast.
     */

  }, {
    key: "recordState",
    value: function recordState() {
      var _this$props3 = this.props,
          history = _this$props3.history,
          app = _this$props3.app;
      var _history$location = history.location,
          pathname = _history$location.pathname,
          search = _history$location.search,
          _history$location$has = _history$location.hash,
          hash = _history$location$has === void 0 ? '' : _history$location$has;

      try {
        history.replace(pathname + hash + search, app.toJSON());
      } catch (e) {
        // If recording the app state fails, clear out the history state
        // we don't want the app restoring a stale state if the user navigates back/forward.
        // Browsers impose a limit on the size of the state object.  Firefox's is the smallest
        // at 640kB, IE11 is 1MB, and Chrome is at least 10MB. Exceeding this limit is the most
        // likely reason for history.replace to fail.
        history.replace(pathname + hash + search, null);
        console.warn('Could not record app state in history.  Will fall back to fetching state from the server when navigating back and forward.');
      }
    }
    /**
     * Adds a css class corresponding to the browser to the body element
     * @private
     */

  }, {
    key: "addDeviceClassesToBody",
    value: function addDeviceClassesToBody() {
      if (isSafari()) {
        document.body.classList.add('moov-safari');
      }
    }
    /**
     * Returns true if client-side navigation should be forced, otherwise false
     * @param {HTMLElement} linkEl
     * @return {Boolean}
     */

  }, {
    key: "shouldNavigateOnClient",
    value: function shouldNavigateOnClient(linkEl) {
      var href = linkEl.getAttribute('href');
      var linkTarget = linkEl.getAttribute('target'); // false if the element is not a link

      if (linkEl.tagName.toLowerCase() !== 'a') return false; // false if the link was rendered by react-storefront/Link - it will handle nav on its own

      if (linkEl.getAttribute('data-moov-link') === 'on') return false; // false if link has data-reload="on|true"

      if (['true', 'on'].indexOf(linkEl.getAttribute('data-reload')) !== -1) return false; // false for links with a target other than self

      if (linkTarget && linkTarget !== '_self') return false;
      return canUseClientSideNavigation(href, this.props.router);
    }
    /**
     * Watches for clicks on all links and forces client-side navigation if the domain is the same.
     * This behavior can be overridden by adding data-reload="on" to any link
     */

  }, {
    key: "watchLinkClicks",
    value: function watchLinkClicks() {
      var _this3 = this;

      // capture click events
      delegate('a', 'click', function (e) {
        var delegateTarget = e.delegateTarget;

        if (_this3.shouldNavigateOnClient(delegateTarget)) {
          // don't reload the page
          e.preventDefault(); // instead do the navigation client-side using the history API

          _this3.props.history.push(delegateTarget.getAttribute('href'));
        }
      });
    }
    /**
     * Resets the scroll position and closes the main menu.
     */

  }]);

  return PWA;
}(Component), _temp)) || _class) || _class) || _class);
export { PWA as default };
//# sourceMappingURL=PWA.js.map