import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import Link from './Link';
import PropTypes from 'prop-types';
import { isAlive } from 'mobx-state-tree';
import merge from 'lodash/merge';
/**
 * A link to a page that automatically set AppModelBase.loading{props.Page}
 * This component wraps react-storefront/Link and supports all of its props.
 */

var PageLink =
/*#__PURE__*/
function (_Component) {
  _inherits(PageLink, _Component);

  function PageLink() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, PageLink);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(PageLink)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "createState", function () {
      var _this$props = _this.props,
          page = _this$props.page,
          model = _this$props.model,
          state = _this$props.state;

      if (isAlive(model)) {
        if (typeof model.createLinkState === 'function') {
          model = model.createLinkState();
        } else if (typeof model.toJSON === 'function') {
          model = model.toJSON();
        }

        if (typeof state === 'function') {
          state = state();
        }

        var result = merge(_defineProperty({
          page: page
        }, "loading".concat(page), _objectSpread({
          id: model.id + '-loading'
        }, model)), state);
        return result;
      }
    });

    return _this;
  }

  _createClass(PageLink, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          model = _this$props2.model,
          page = _this$props2.page,
          others = _objectWithoutProperties(_this$props2, ["model", "page"]);

      return React.createElement(Link, _extends({
        to: model.url
      }, others, {
        state: this.createState
      }));
    }
  }]);

  return PageLink;
}(Component);

_defineProperty(PageLink, "propTypes", {
  /**
   * An instance of a mobx-state-tree Model to link to
   */
  model: PropTypes.object.isRequired,

  /**
   * The page to display when clicked.
   */
  page: PropTypes.string.isRequired,

  /**
   * An object to apply to the state tree when the link is clicked.
   */
  state: PropTypes.object
});

export { PageLink as default };
//# sourceMappingURL=PageLink.js.map