import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React from 'react';
import ButtonSelector from './ButtonSelector';
import AmpState from './amp/AmpState';
/**
 *
 * The `ProductColors` component renders a given Product's color options within a ButtonSelector.
 * It also handles the AMP state for the particular product, such as updating the accompanying thumbnail image.
 *
 */

export default function ProductColors(_ref) {
  var product = _ref.product,
      props = _objectWithoutProperties(_ref, ["product"]);

  return React.createElement(AmpState, {
    id: "rsfProduct".concat(product.id),
    initialState: product.toJSON()
  }, React.createElement(ButtonSelector, _extends({
    small: true,
    name: "color"
  }, props, {
    model: product.color
  })));
}
//# sourceMappingURL=ProductColors.js.map