import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import PageLink from './PageLink';
/**
 * A link to the PDP which reuses the thumbnail image from the Subcategory page.
 * The product prop accepts an instance of ProductModelBase or any model that implements createLinkState().
 * This component wraps react-storefront/Link and supports all of its props.
 */

var ProductLink =
/*#__PURE__*/
function (_Component) {
  _inherits(ProductLink, _Component);

  function ProductLink() {
    _classCallCheck(this, ProductLink);

    return _possibleConstructorReturn(this, _getPrototypeOf(ProductLink).apply(this, arguments));
  }

  _createClass(ProductLink, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          product = _this$props.product,
          others = _objectWithoutProperties(_this$props, ["product"]);

      return React.createElement(PageLink, _extends({
        page: "Product",
        model: product,
        anchorProps: {
          'data-th': 'product-link'
        }
      }, others));
    }
  }]);

  return ProductLink;
}(Component);

_defineProperty(ProductLink, "propTypes", {
  /**
   * An instance of ProductModelBase or a model that implements createLinkState()
   */
  product: PropTypes.object.isRequired
});

export { ProductLink as default };
//# sourceMappingURL=ProductLink.js.map