import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";

var _class;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React from 'react';
import { observer } from 'mobx-react';
import Image from './Image';
/**
 *
 * The `ProductThumbnail` component renders the given Product's selected thumbnail image.
 * It uses the selected color option's `thumbnail` property as the source of the image.
 *
 * You can customize this property when building your product model data in the handlers.
 *
 */

var ProductThumbnail = observer(_class =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ProductThumbnail, _React$Component);

  function ProductThumbnail() {
    _classCallCheck(this, ProductThumbnail);

    return _possibleConstructorReturn(this, _getPrototypeOf(ProductThumbnail).apply(this, arguments));
  }

  _createClass(ProductThumbnail, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          product = _this$props.product,
          props = _objectWithoutProperties(_this$props, ["product"]);

      var color = "rsfProduct".concat(product.id, ".color");
      return React.createElement(Image, _extends({}, props, {
        src: product.color.selected.thumbnail || product.thumbnail,
        "amp-bind": "src=>".concat(color, ".selected.thumbnail || \"").concat(product.thumbnail, "\"")
      }));
    }
  }]);

  return ProductThumbnail;
}(React.Component)) || _class;

export { ProductThumbnail as default };
//# sourceMappingURL=ProductThumbnail.js.map