import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/es6.function.name";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { withStyles } from '@material-ui/core/';
import PropTypes from 'prop-types';
import Link from './Link';
import Track from './Track';
import Image from './Image';
import classnames from 'classnames';
export var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      justifyContent: 'center',
      zIndex: theme.zIndex.appBar - 1,
      cursor: 'pointer'
    },
    img: {
      width: '100%',
      height: '100%',
      zIndex: theme.zIndex.appBar - 1
    }
  };
};
/**
 * A promo banner that automatically fires the promo_banner_clicked analytics event.
 * Additional props are spread to the Link component
 */

var PromoBanner = (_dec = withStyles(styles, {
  name: 'RSFPromoBanner'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(PromoBanner, _Component);

  function PromoBanner() {
    _classCallCheck(this, PromoBanner);

    return _possibleConstructorReturn(this, _getPrototypeOf(PromoBanner).apply(this, arguments));
  }

  _createClass(PromoBanner, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          href = _this$props.href,
          classes = _this$props.classes,
          onClick = _this$props.onClick,
          name = _this$props.name,
          src = _this$props.src,
          alt = _this$props.alt,
          imgProps = _this$props.imgProps,
          className = _this$props.className,
          others = _objectWithoutProperties(_this$props, ["href", "classes", "onClick", "name", "src", "alt", "imgProps", "className"]);

      return React.createElement(Track, {
        event: "promoBannerClicked",
        name: name,
        imageUrl: src
      }, React.createElement(Link, _extends({}, others, {
        to: href,
        className: classnames(className, classes.root),
        onClick: onClick
      }), React.createElement(Image, _extends({
        className: classes.img,
        src: src,
        alt: alt,
        contain: true
      }, imgProps))));
    }
  }]);

  return PromoBanner;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * A css class to apply
   */
  className: PropTypes.string,

  /**
   * CSS classes
   */
  classes: PropTypes.object,

  /**
   * An name to idenify the banner with analytics
   */
  name: PropTypes.string,

  /**
   * The url to load for the banner image
   */
  src: PropTypes.string,

  /**
   * The location to navigate to when clicked
   */
  href: PropTypes.string,

  /**
   * An alt value for the img tag
   */
  alt: PropTypes.string,

  /**
   * Additional props for the img tag
   */
  imgProps: PropTypes.object
}), _defineProperty(_class2, "defaultProps", {
  name: 'promo',
  alt: 'promo',
  imgProps: {}
}), _temp)) || _class);
export { PromoBanner as default };
//# sourceMappingURL=PromoBanner.js.map