import _extends from "@babel/runtime/helpers/extends";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import "core-js/modules/es6.function.name";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Fragment, Component } from 'react';
import Add from '@material-ui/icons/Add';
import Remove from '@material-ui/icons/Remove';
import IconButton from '@material-ui/core/IconButton';
import Input from '@material-ui/core/Input';
import withStyles from '@material-ui/core/styles/withStyles';
import PropTypes from 'prop-types';
import { observer, inject } from 'mobx-react';
export var styles = function styles(theme) {
  return {
    root: {
      backgroundColor: theme.palette.divider,
      border: 'none',
      width: '110px',
      padding: 0
    },
    icon: {
      fontSize: theme.typography.title.fontSize,
      position: 'relative'
    },
    button: {
      height: '36px',
      width: '36px',
      padding: 0
    },
    input: {
      color: theme.typography.body1.color,
      textAlign: 'center',
      padding: 0
    },
    focused: {
      backgroundColor: theme.palette.divider
    },
    underline: {
      '&::before': {
        display: 'none'
      }
    }
  };
};
/**
 * A quantity selector with plus and minus buttons. Any extra props are spread to the
 * underlying Material UI input element.
 */

var QuantitySelector = (_dec = inject(function (_ref) {
  var app = _ref.app,
      ampStateId = _ref.ampStateId;
  return {
    app: app,
    ampStateId: ampStateId
  };
}), _dec2 = withStyles(styles, {
  name: 'RSFQuantitySelector'
}), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(QuantitySelector, _Component);

  function QuantitySelector() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, QuantitySelector);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(QuantitySelector)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onChange", function (value) {
      var _this$props = _this.props,
          minValue = _this$props.minValue,
          maxValue = _this$props.maxValue,
          product = _this$props.product;

      if (value >= minValue && value <= maxValue) {
        _this.props.onChange(value);

        if (product) {
          product.setQuantity(value);
        }
      }
    });

    return _this;
  }

  _createClass(QuantitySelector, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          name = _this$props2.name,
          app = _this$props2.app,
          classes = _this$props2.classes,
          addIcon = _this$props2.addIcon,
          subtractIcon = _this$props2.subtractIcon,
          value = _this$props2.value,
          minValue = _this$props2.minValue,
          maxValue = _this$props2.maxValue,
          analytics = _this$props2.analytics,
          product = _this$props2.product,
          inputProps = _this$props2.inputProps,
          ampStateId = _this$props2.ampStateId,
          ariaLabel = _this$props2.ariaLabel,
          other = _objectWithoutProperties(_this$props2, ["name", "app", "classes", "addIcon", "subtractIcon", "value", "minValue", "maxValue", "analytics", "product", "inputProps", "ampStateId", "ariaLabel"]);

      if (product) {
        value = product.quantity;
      }

      var quantitySelector = classes.quantitySelector,
          icon = classes.icon,
          button = classes.button,
          inputClasses = _objectWithoutProperties(classes, ["quantitySelector", "icon", "button"]);

      var bindProps = _defineProperty({
        inputProps: _objectSpread({
          'aria-label': ariaLabel,
          name: name
        }, inputProps, {
          'amp-bind': "value=>".concat(ampStateId, ".quantity")
        })
      }, app.amp ? 'readOnly' : 'disabled', true);

      return React.createElement(Fragment, null, React.createElement(Input, _extends({
        startAdornment: React.createElement(IconButton, {
          size: "small",
          classes: {
            root: button
          },
          onClick: function onClick() {
            return _this2.onChange(value - 1);
          },
          "aria-label": "add one ".concat(ariaLabel),
          on: "tap:AMP.setState({ ".concat(ampStateId, ": { quantity: max(").concat(minValue, ", (").concat(ampStateId, ".quantity || ").concat(value, ") - 1) } })")
        }, subtractIcon || React.createElement(Remove, {
          classes: {
            root: icon
          }
        })),
        endAdornment: React.createElement(IconButton, {
          size: "small",
          classes: {
            root: button
          },
          onClick: function onClick() {
            return _this2.onChange(value + 1);
          },
          "aria-label": "subtract one ".concat(ariaLabel),
          on: "tap:AMP.setState({ ".concat(ampStateId, ": { quantity: min(").concat(maxValue, ", (").concat(ampStateId, ".quantity || ").concat(value, ") + 1) } })")
        }, addIcon || React.createElement(Add, {
          classes: {
            root: icon
          }
        })),
        onChange: this.onChange,
        value: value,
        classes: _objectSpread({
          underline: classes.underline
        }, inputClasses)
      }, bindProps, other)));
    }
  }]);

  return QuantitySelector;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The name to apply to the input when rendering AMP.
   */
  name: PropTypes.string,

  /**
   * CSS classes
   */
  classes: PropTypes.object,

  /**
   * The plus icon
   */
  addIcon: PropTypes.element,

  /**
   * The minus icon
   */
  subtractIcon: PropTypes.element,

  /**
   * The current value
   */
  value: PropTypes.number,

  /**
   * The minimum value.  Defaults to 1.
   */
  minValue: PropTypes.number,

  /**
   * The maximum value.  Defaults to 100.
   */
  maxValue: PropTypes.number,

  /**
   * Called when the value is changed.  The new value is passed as the only argument
   */
  onChange: PropTypes.func,

  /**
   * If specified, this component will automatically control the price of a product.
   * This should be an instance of ProductModelBase
   */
  product: PropTypes.object,

  /**
   * The accessibility label.  Add and subtract button aria-label values are derived from this as "add one {ariaLabel}" and "subtract one {ariaLabel}"
   */
  ariaLabel: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  name: 'quantity',
  onChange: Function.prototype,
  minValue: 1,
  maxValue: 100,
  value: 1,
  ariaLabel: 'quantity'
}), _temp)) || _class) || _class) || _class);
export { QuantitySelector as default };
//# sourceMappingURL=QuantitySelector.js.map