import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import Star from '@material-ui/icons/Star';
import StarBorder from '@material-ui/icons/StarBorder';
import StarHalf from '@material-ui/icons/StarHalf';
import withStyles from '@material-ui/core/styles/withStyles';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { Hbox } from './Box';
/**
 * Displays a star rating corresponding to the provided value
 */

export var styles = function styles(theme) {
  return {
    root: {
      display: 'flex',
      '& svg': {
        color: theme.palette.rating,
        height: '16px',
        width: '16px',
        display: 'block'
      }
    },
    filledEmpty: {
      fill: theme.palette.divider
    },
    blank: {
      '& svg': {
        color: theme.palette.divider
      }
    },
    reviewsLabel: {
      marginLeft: '3px'
    }
  };
};
var Rating = (_dec = withStyles(styles, {
  name: 'RSFRating'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Rating, _Component);

  function Rating() {
    _classCallCheck(this, Rating);

    return _possibleConstructorReturn(this, _getPrototypeOf(Rating).apply(this, arguments));
  }

  _createClass(Rating, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          iconFull = _this$props.iconFull,
          iconHalf = _this$props.iconHalf,
          iconEmpty = _this$props.iconEmpty,
          classes = _this$props.classes,
          value = _this$props.value,
          label = _this$props.label,
          reviewCount = _this$props.reviewCount,
          className = _this$props.className,
          product = _this$props.product,
          fillEmpty = _this$props.fillEmpty;
      var stars = [];

      if (product) {
        reviewCount = product.reviewCount;
        value = product.rating;
      }

      var IconFull = iconFull || Star;
      var IconHalf = iconHalf || StarHalf;
      var IconEmpty = iconEmpty || StarBorder;

      for (var i = 1; i <= 5; i++) {
        if (value == null || value >= i) {
          stars.push(React.createElement(IconFull, {
            key: i
          }));
        } else if (value >= i - 0.5) {
          stars.push(React.createElement(IconHalf, {
            key: i
          }));
        } else if (fillEmpty) {
          stars.push(React.createElement(IconFull, {
            className: classes.filledEmpty,
            key: i
          }));
        } else {
          stars.push(React.createElement(IconEmpty, {
            key: i
          }));
        }
      }

      return React.createElement(Hbox, null, React.createElement("div", {
        className: classnames(classes.root, className, _defineProperty({}, classes.blank, value == null))
      }, stars), reviewCount ? React.createElement("div", {
        className: classes.reviewsLabel
      }, "(", reviewCount, label(reviewCount), ")") : null);
    }
  }]);

  return Rating;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * CSS classes to apply
   */
  classes: PropTypes.object,

  /**
   * The number of stars to display.  Can be an integer or a float
   * ending in .5.
   */
  value: PropTypes.number,

  /**
   * The number of reviews
   */
  reviewCount: PropTypes.number,

  /**
   * A function that returns the label displayed to the right of the review count.
   * For example: `<Rating label={reviewCount => <span> {reviewCount == 1 ? 'review' : 'reviews'}</span>}/>`.
   * This value used in this example is the default.
   */
  label: PropTypes.func,

  /**
   * An instance of ProductModelBase.  You can set this instead of setting value an reviewCount individually.
   */
  product: PropTypes.object,

  /**
   * Custom full point icon
   */
  iconFull: PropTypes.func,

  /**
   * Custom half point icon
   */
  iconHalf: PropTypes.func,

  /**
   * Custom empty icon, will override fillEmpty icon
   */
  iconEmpty: PropTypes.func,

  /**
   * Use filled icon with light grey background for empty icon
   */
  fillEmpty: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  label: function label(reviewCount) {
    return React.createElement("span", null, " ", reviewCount == 1 ? 'review' : 'reviews');
  },
  fillEmpty: false
}), _temp)) || _class);
export { Rating as default };
//# sourceMappingURL=Rating.js.map