import "core-js/modules/es6.regexp.match";
import "core-js/modules/es7.array.includes";
import "core-js/modules/es6.string.includes";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { inject, observer } from 'mobx-react';
import RedboxReact from 'redbox-react';
import uniq from 'lodash/uniq';
import withStyles from '@material-ui/core/styles/withStyles';
export var styles = function styles(theme) {
  var _amp;

  return {
    amp: (_amp = {
      fontWeight: 'bold',
      backgroundColor: 'red',
      color: 'white',
      position: 'fixed',
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      overflow: 'auto',
      zIndex: theme.zIndex.amp.modal + 10,
      padding: "".concat(theme.margins.container, "px"),
      whiteSpace: 'pre-wrap'
    }, _defineProperty(_amp, "fontWeight", 'bold'), _defineProperty(_amp, "margin", 0), _amp)
  };
};
/**
 * A basic error view for use in development.  Since this shows a low-level error message and stack trace,
 * you should replace this with something more user-friendly in production.
 */

var Redbox = (_dec = withStyles(styles, {
  name: 'RSFRedbox'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class =
/*#__PURE__*/
function (_Component) {
  _inherits(Redbox, _Component);

  function Redbox() {
    _classCallCheck(this, Redbox);

    return _possibleConstructorReturn(this, _getPrototypeOf(Redbox).apply(this, arguments));
  }

  _createClass(Redbox, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // log original error message to the console
      var _this$props$app = this.props.app,
          error = _this$props$app.error,
          stack = _this$props$app.stack;
      console.error(this.reformat(error));
      console.error(this.createError(error, stack));
    }
  }, {
    key: "render",
    value: function render() {
      // render improved error message
      var _this$props = this.props,
          _this$props$app2 = _this$props.app,
          error = _this$props$app2.error,
          stack = _this$props$app2.stack,
          amp = _this$props$app2.amp,
          classes = _this$props.classes;

      if (!error) {
        return null;
      } else if (amp) {
        return React.createElement("pre", {
          className: classes.amp
        }, this.reformat(error), React.createElement("br", null), React.createElement("br", null), stack);
      } else {
        return React.createElement(RedboxReact, {
          error: this.createError(this.reformat(error), stack)
        });
      }
    }
    /**
     * Creates an Error with the specified message and stack
     * @param {String} message
     * @param {String[]} stack
     * @return {Error}
     */

  }, {
    key: "createError",
    value: function createError(message, stack) {
      var error = new Error(this.reformat(message));
      error.stack = stack;
      return error;
    }
    /**
     * Adds additional helpful info to an error message
     * @param {String} message The original error message
     * @return {String}
     */

  }, {
    key: "reformat",
    value: function reformat(message) {
      try {
        if (message.includes('[mobx-state-tree] Error while converting')) {
          // mobx-state-tree error
          var filename = (message.match(/"filename":"(\w+)"/) || [])[1];
          var model = message.match(/is not assignable to type: `\((\w+) \|/)[1];
          var paths = message.match(/at path "([^"]*)"/g).map(function (path) {
            return path.match(/at path "([^"]*)"/)[1];
          });
          return "mobx-state-tree - attempted to assign a value of incorrect type to ".concat(uniq(paths).join(', ')).concat(model === 'AnonymousModel' ? '' : " in ".concat(model)).concat(filename ? ' (' + filename + ')' : '', ".");
        } else {
          return message;
        }
      } catch (e) {
        return message;
      }
    }
  }]);

  return Redbox;
}(Component)) || _class) || _class) || _class);
export { Redbox as default };
//# sourceMappingURL=Redbox.js.map