import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/es6.regexp.replace";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import Button from '@material-ui/core/Button';
import CircularProgress from '@material-ui/core/CircularProgress';
import withStyles from '@material-ui/core/styles/withStyles';
import { observer, inject } from 'mobx-react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import VisibilitySensor from 'react-visibility-sensor';
export var styles = function styles(theme) {
  return {
    root: {
      margin: '15px 0',
      width: '100%'
    },
    loading: {
      display: 'flex',
      height: 45,
      justifyContent: 'center'
    }
  };
};
/**
 * The ShowMore component controls pagination for views that display a SearchResultsModelBase (specified via the model prop).
 * This component uses either the total or numberOfPages fields on SearchResultsModelBase to determine whether or not
 * to trigger show more. The default variant is a button with text/contents can be changed by specifying a child (string or components).
 * Or this component can be configured to use infinite scrolling for triggering another page.
 */

var ShowMore = (_dec = withStyles(styles, {
  name: 'RSFShowMore'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(ShowMore, _Component);

  function ShowMore() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, ShowMore);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(ShowMore)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onVisibilityChange", function (isVisible) {
      var model = _this.props.model;

      if (isVisible && !model.loadingMore) {
        model.showMore();
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function () {
      var model = _this.props.model;
      model.showMore();
    });

    return _this;
  }

  _createClass(ShowMore, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          app = _this$props.app,
          Loading = _this$props.Loading,
          model = _this$props.model,
          classes = _this$props.classes,
          className = _this$props.className,
          children = _this$props.children,
          infiniteScroll = _this$props.infiniteScroll,
          offset = _this$props.offset,
          others = _objectWithoutProperties(_this$props, ["app", "Loading", "model", "classes", "className", "children", "infiniteScroll", "offset"]);

      if (model.loadingMore) {
        return React.createElement("div", {
          className: classnames(classes.loading, classes.root)
        }, React.createElement(Loading, null));
      } else if (model.hasMoreItems) {
        if (infiniteScroll && !app.amp) {
          return React.createElement(VisibilitySensor, {
            key: model.page,
            offset: {
              bottom: -offset
            },
            onChange: this.onVisibilityChange
          }, React.createElement("div", {
            style: {
              width: 1,
              height: 1
            }
          }));
        }

        return React.createElement(Button, _extends({
          variant: "contained",
          color: "primary",
          href: app.amp ? "".concat(app.location.pathname.replace(/\.amp/, ''), "?page=1#item-").concat(model.pageSize) : null,
          className: classnames(classes.root, className),
          onClick: this.onClick
        }, others), children || 'Show More');
      } else {
        return null;
      }
    }
  }]);

  return ShowMore;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * A renderer for the loading icon.  Uses CircularPropgress by default
   */
  loading: PropTypes.func,

  /**
   * An instance of `SearchResultModelBase`
   */
  model: PropTypes.object,

  /**
   * CSS classes
   */
  classes: PropTypes.object,

  /**
   * When infiniteScroll is set to true, this prop describes how near to the bottom of the page in pixels the user must scroll before the next page is fetched.
   */
  offset: PropTypes.number,

  /**
   * Set to true to automatically fetch the next page when the user scrolls to the bottom of the page instead of displaying a "Show More" button.
   */
  infiniteScroll: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  Loading: function Loading() {
    return React.createElement(CircularProgress, null);
  },
  offset: 100
}), _temp)) || _class) || _class) || _class);
export { ShowMore as default };
//# sourceMappingURL=ShowMore.js.map