import "core-js/modules/es6.function.name";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import withStyles from '@material-ui/core/styles/withStyles';
import { inject, observer } from 'mobx-react';
import Button from '@material-ui/core/Button';
import MenuItem from '@material-ui/core/MenuItem';
import PropTypes from 'prop-types';
import Hidden from '@material-ui/core/Hidden';
/**
 * UI for sorting an instance of SearchResultModelBase.  This component can be used on its own, or you can use
 * SortButton to automatically display this component in a drawer that slides up from the bottom of the viewport.
 */

export var styles = function styles(theme) {
  return {
    container: {
      padding: '15px 0 0 15px'
    },
    option: {
      boxShadow: 'none',
      width: 'calc(50% - 15px)',
      margin: '0 15px 15px 0'
    }
  };
};
var Sort = (_dec = withStyles(styles, {
  name: 'RSFSort'
}), _dec2 = inject('router'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Sort, _Component);

  function Sort() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Sort);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Sort)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function (option, e) {
      var _this$props = _this.props,
          onSelect = _this$props.onSelect,
          model = _this$props.model,
          queryParam = _this$props.queryParam,
          router = _this$props.router;
      onSelect(option, e);

      if (!e.isDefaultPrevented()) {
        router.applySearch(_defineProperty({}, queryParam, option.code));
        model.setSort(option);
        model.refresh();
      }
    });

    return _this;
  }

  _createClass(Sort, [{
    key: "render",
    value: function render() {
      var variant = this.props.variant;
      Hidden;

      if (variant === 'buttons') {
        return this.renderButtons();
      } else if (variant === 'menu-items') {
        return this.renderMenu();
      } else {
        return null;
      }
    }
  }, {
    key: "renderButtons",
    value: function renderButtons() {
      var _this2 = this;

      var _this$props2 = this.props,
          model = _this$props2.model,
          classes = _this$props2.classes;
      var options = model.sortOptions;
      return React.createElement("div", {
        className: classes.container,
        onClick: this.handleSort
      }, options && options.map(function (option, i) {
        return React.createElement(Button, {
          className: classes.option,
          color: model.sort === option.code ? 'primary' : 'default',
          variant: "contained",
          onClick: _this2.onClick.bind(_this2, option),
          key: i
        }, option.name);
      }));
    }
  }, {
    key: "renderMenu",
    value: function renderMenu() {
      var _this3 = this;

      var model = this.props.model;
      var options = model.sortOptions;
      return React.createElement(Fragment, null, options && options.map(function (option, i) {
        return React.createElement(MenuItem, {
          key: i,
          onClick: _this3.onClick.bind(_this3, option)
        }, option.name);
      }));
    }
  }]);

  return Sort;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * A function to call when a sort option is selected.  The option and event are passed.
   * The default behavior can be prevented by called `preventDefault()` on the passed in event.
   */
  onSelect: PropTypes.func,

  /**
   * A instance of SearchResultsModelBase
   */
  model: PropTypes.object,

  /**
   * The query string parameter that should be updated when the sort is changed.  The value will the
   * code corresponding to the selected sortOption.  Defaults to "sort".
   */
  queryParam: PropTypes.string,

  /**
   * Controls how sort options are displayed.  Can be "menu-items" or "buttons".  Defaults to "buttons"
   */
  variant: PropTypes.oneOf(['menu-items', 'buttons'])
}), _defineProperty(_class2, "defaultProps", {
  onSelect: Function.prototype,
  queryParam: 'sort',
  variant: 'buttons'
}), _temp)) || _class) || _class) || _class);
export { Sort as default };
//# sourceMappingURL=Sort.js.map