import _extends from "@babel/runtime/helpers/extends";
import "core-js/modules/es6.function.name";
import "core-js/modules/es6.regexp.replace";
import "core-js/modules/es6.array.find";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import "core-js/modules/es6.regexp.search";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { observer, inject } from 'mobx-react';
import ActionButton from './ActionButton';
import Sort from './Sort';
import PropTypes from 'prop-types';
import Drawer from './Drawer';
import Hidden from '@material-ui/core/Hidden';
import Menu from '@material-ui/core/Menu';
/**
 * A button that when clicked, opens a drawer containing the `Sort` view. The name of the currently
 * selected sortOption is display in the button text.
 */

var SortButton = (_dec = inject('app'), _dec(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(SortButton, _Component);

  function SortButton(_ref) {
    var _this;

    var app = _ref.app,
        variant = _ref.variant;

    _classCallCheck(this, SortButton);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SortButton).call(this));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onClick", function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(e);
      }

      if (!e.defaultPrevented) {
        _this.toggleOpen(true, e.currentTarget);
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "close", function () {
      _this.toggleOpen(false);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "toggleOpen", function (open, anchorEl) {
      if (open) {
        _this.setState({
          mountDrawer: true,
          open: true,
          anchorEl: anchorEl
        });
      } else {
        _this.setState({
          open: false,
          anchorEl: null
        });
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onSelect", function () {
      _this.toggleOpen(false);
    });

    var _open = variant === 'drawer' && app.location.search.indexOf('openSort') !== -1;

    _this.state = {
      open: _open,
      mountDrawer: _open,
      anchorEl: null
    };
    return _this;
  }

  _createClass(SortButton, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          app = _this$props.app,
          variant = _this$props.variant,
          model = _this$props.model,
          title = _this$props.title,
          drawerProps = _this$props.drawerProps,
          sortProps = _this$props.sortProps,
          props = _objectWithoutProperties(_this$props, ["app", "variant", "model", "title", "drawerProps", "sortProps"]);

      var _this$state = this.state,
          open = _this$state.open,
          mountDrawer = _this$state.mountDrawer,
          anchorEl = _this$state.anchorEl;
      var selectedOption = model.sortOptions.find(function (o) {
        return model.sort === o.code;
      });
      return React.createElement(Fragment, null, React.createElement(ActionButton, _extends({
        key: "button",
        href: app.amp ? "".concat(app.location.pathname.replace(/\.amp/, ''), "?openSort") : null,
        label: title,
        value: selectedOption && selectedOption.name
      }, props, {
        onClick: this.onClick
      })), !app.amp && variant === 'drawer' && React.createElement(Hidden, {
        smUp: true
      }, React.createElement(Drawer, _extends({
        ModalProps: {
          keepMounted: true
        },
        key: "drawer",
        anchor: "bottom",
        title: title,
        open: open,
        onRequestClose: this.toggleOpen.bind(this, false)
      }, drawerProps), mountDrawer && React.createElement(Sort, _extends({
        model: model,
        onSelect: this.onSelect
      }, sortProps)))), !app.amp && variant === 'menu' && React.createElement(Hidden, {
        xsDown: true
      }, React.createElement(Menu, {
        open: open,
        anchorEl: anchorEl,
        onClose: this.close
      }, React.createElement(Sort, _extends({
        variant: "menu-items",
        model: model,
        onSelect: this.onSelect
      }, sortProps)))));
    }
  }]);

  return SortButton;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * A instance of SearchResultsModelBase
   */
  model: PropTypes.object,

  /**
   * CSS classes
   */
  classes: PropTypes.object,

  /**
   * Sets the type of control displayed when the menu is clicked
   */
  variant: PropTypes.oneOf(['drawer', 'menu']),

  /**
   * Props to pass to the underlying `Drawer` component.
   */
  drawerProps: PropTypes.object,

  /**
   * Props to pass to the underlying `Sort` component.
   */
  sortProps: PropTypes.object,

  /**
   * Text for the button label and the drawer header.  Defaults to "Sort".
   */
  title: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  title: 'Sort',
  variant: 'drawer',
  drawerProps: {},
  sortProps: {}
}), _temp)) || _class) || _class);
export { SortButton as default };
//# sourceMappingURL=SortButton.js.map