import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PageLink from './PageLink';
import PropTypes from 'prop-types';
/**
 * A link to a subcategory that automatically pushes the product's thumbnail into the product skeleton
 * via AppModelBase.loadingProduct. The subcategory prop accepts an instance of SubcategoryModelBase or any
 * model that implements createLinkState(). This components wraps react-storefront/Link and supports all of its props.
 */

var SubcategoryLink =
/*#__PURE__*/
function (_Component) {
  _inherits(SubcategoryLink, _Component);

  function SubcategoryLink() {
    _classCallCheck(this, SubcategoryLink);

    return _possibleConstructorReturn(this, _getPrototypeOf(SubcategoryLink).apply(this, arguments));
  }

  _createClass(SubcategoryLink, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          subcategory = _this$props.subcategory,
          others = _objectWithoutProperties(_this$props, ["subcategory"]);

      return React.createElement(PageLink, _extends({
        page: "Subcategory",
        model: subcategory,
        anchorProps: {
          'data-th': 'subcategory-link'
        }
      }, others));
    }
  }]);

  return SubcategoryLink;
}(Component);

_defineProperty(SubcategoryLink, "propTypes", {
  /**
   * An instance of SubcategoryModelBase
   */
  subcategory: PropTypes.object.isRequired
});

export { SubcategoryLink as default };
//# sourceMappingURL=SubcategoryLink.js.map