import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import "core-js/modules/es6.string.link";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import classnames from 'classnames';
import Image from './Image';
import React, { Component, Fragment } from 'react';
import PropTypes from 'prop-types';
import { PropTypes as MobxPropTypes, inject, observer } from 'mobx-react';
import Tabs from '@material-ui/core/Tabs';
import Tab from '@material-ui/core/Tab';
import withStyles from '@material-ui/core/styles/withStyles';
import Link from './Link';
export var styles = function styles(theme) {
  return {
    indicator: {
      height: '3px',
      transition: 'left 300ms cubic-bezier(0.4, 0, 0.2, 1) 0ms'
    },
    noSelection: {
      visibility: 'hidden'
    },
    root: {
      '& a': {
        textDecoration: 'none',
        color: 'inherit'
      }
    },
    tab: {
      fontWeight: 300,
      height: '100%',
      minWidth: '20px',
      position: 'relative'
    },
    selectedTab: {
      fontWeight: 500,
      opacity: 1
    },
    scroller: {
      '&::-webkit-scrollbar': {
        display: 'none'
      }
    },
    link: {
      display: 'block',
      height: '100%',
      fontSize: theme.typography.body1.fontSize
    },
    centered: {
      '&::before,&::after': {
        display: 'block',
        content: "''",
        flex: 1
      }
    }
  };
};
/**
 * A set of tabs.  Tabs are built from an array of model instances provided via the `items` prop.
 */

var TabsRow = (_dec = withStyles(styles, {
  name: 'RSFTabsRow'
}), _dec2 = inject('app'), _dec(_class = _dec2(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(TabsRow, _Component);

  function TabsRow(props) {
    var _this;

    _classCallCheck(this, TabsRow);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(TabsRow).call(this, props));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleChange", function (event, newValue) {
      _this.setState({
        selectedIdx: newValue
      }, function () {
        if (_this.props.onTabChange) {
          _this.props.onTabChange(event, newValue);
        }
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "renderLabel", function (item) {
      var classes = _this.props.classes;
      return item.url ? React.createElement(Link, {
        className: classes.link,
        to: item.url,
        prefetch: item.prefetch,
        onClick: _this.onLinkClick
      }, item.text) : item.text;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onLinkClick", function (e) {
      e.preventDefault();
    });

    _this.state = {
      selectedIdx: props.initialSelectedIdx
    };
    return _this;
  }

  _createClass(TabsRow, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.initialSelectedIdx !== this.initialSelectedIdx) {
        this.setState({
          selectedIdx: nextProps.initialSelectedIdx
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          app = _this$props.app,
          tabRenderer = _this$props.tabRenderer,
          centered = _this$props.centered,
          items = _this$props.items,
          classes = _this$props.classes,
          imageProps = _this$props.imageProps,
          scrollable = _this$props.scrollable,
          initialSelectedIdx = _this$props.initialSelectedIdx,
          onTabChange = _this$props.onTabChange,
          elevation = _this$props.elevation,
          tabsProps = _objectWithoutProperties(_this$props, ["app", "tabRenderer", "centered", "items", "classes", "imageProps", "scrollable", "initialSelectedIdx", "onTabChange", "elevation"]);

      var selectedIdx = this.state.selectedIdx;
      return React.createElement(Tabs, _extends({
        value: selectedIdx == null ? false : selectedIdx,
        onChange: this.handleChange,
        indicatorColor: "secondary",
        variant: scrollable ? 'scrollable' : null,
        className: classes.root,
        classes: {
          root: classes.root,
          indicator: classnames(classes.indicator, _defineProperty({}, classes.noSelection, selectedIdx == null)),
          flexContainer: classnames(_defineProperty({}, classes.centered, centered)),
          scroller: classes.scroller
        }
      }, tabsProps), items.map(function (item, i) {
        var icon;

        if (item.imageUrl) {
          icon = React.createElement(Image, _extends({
            src: item.imageUrl,
            alt: item.alt
          }, imageProps));

          if (app.amp && item.url) {
            icon = React.createElement(Link, {
              to: item.url
            }, icon);
          }
        }

        if (tabRenderer) {
          var itemWithClasses = _objectSpread({}, item, {
            classes: {
              root: classes.tab
            }
          });

          return tabRenderer(itemWithClasses, i);
        } else {
          return React.createElement(Tab, {
            key: i,
            label: _this2.renderLabel(item),
            icon: icon,
            classes: {
              root: classes.tab,
              selected: classes.selectedTab
            }
          });
        }
      }));
    }
  }]);

  return TabsRow;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * Index of tab that should be selected by default
   */
  initialSelectedIdx: PropTypes.number,

  /**
   * Overridable classes object to allow customization of component
   */
  classes: PropTypes.objectOf(PropTypes.string),

  /**
   * Array of items that should be rendered
   */
  items: MobxPropTypes.arrayOrObservableArrayOf(PropTypes.shape({
    imageUrl: PropTypes.string,
    alt: PropTypes.string,
    text: PropTypes.string
  })).isRequired,

  /**
   * Props for displayed images. See <Image /> component for details
   */
  imageProps: PropTypes.object,

  /**
   * Material-UI setting to control horizontal scrolling for tabs
   */
  scrollable: PropTypes.bool,

  /**
   * Callback function for tab change
   */
  onTabChange: PropTypes.func,

  /**
   * Set to true to center the tabs
   */
  centered: PropTypes.bool,

  /**
   * A function to override the default rendering of each tab's label.  The function is passed the MenuItem model
   * corresponding to the item to be rendered.
   */
  tabRenderer: PropTypes.func
}), _defineProperty(_class2, "defaultProps", {
  items: [],
  variant: 'scrollable',
  centered: false
}), _temp)) || _class) || _class) || _class);
export { TabsRow as default };
//# sourceMappingURL=TabsRow.js.map