import "core-js/modules/es6.function.name";
import "core-js/modules/es7.symbol.async-iterator";
import "core-js/modules/es6.symbol";
import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import "regenerator-runtime/runtime";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import "core-js/modules/es6.regexp.to-string";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import "core-js/modules/es6.array.find";
import "core-js/modules/web.dom.iterable";
import "core-js/modules/es6.array.iterator";
import "core-js/modules/es6.object.keys";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { inject } from 'mobx-react';
import PropTypes from 'prop-types';
import escape from 'lodash/escape';
import analytics, { getTargets } from './analytics';
import merge from 'lodash/merge';
var nextId = 0;
var ampAnalyticsTypes = {};
/**
 * @private
 * Used to reset the id for repeatable test results.
 */

export function resetId() {
  nextId = 0;
}
/**
 * Fires an analytics event when the user interacts with the child component.  By default this fires when the user
 * clicks on the child component, but this can be overriden using the `trigger` prop.  The value of trigger should
 * be the name of the event prop to bind to. All additional props will be passed as options along with the event.
 *
 * Example:
 *
 * <Track event="addedToCart" product={this.props.product}>
 *  <Button>Add to Cart</Button>
 * </Track>
 */

var Track = (_dec = inject('app'), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Track, _Component);

  function Track() {
    var _this;

    _classCallCheck(this, Track);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Track).call(this));
    _this.id = (nextId++).toString();
    return _this;
  }

  _createClass(Track, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      if (this.props.app.amp) {
        var _this$props = this.props,
            event = _this$props.event,
            trigger = _this$props.trigger,
            app = _this$props.app,
            children = _this$props.children,
            onSuccess = _this$props.onSuccess,
            data = _objectWithoutProperties(_this$props, ["event", "trigger", "app", "children", "onSuccess"]);

        this.createAmpTriggers(data);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.attachEvent();
    }
    /**
     * Fires the analytics event asynchronously using setImmediate so as not to
     * block the render loop.
     * @param {String} e The event to fire
     */

  }, {
    key: "fireEvent",
    value: function fireEvent(e) {
      var _this$props2 = this.props,
          event = _this$props2.event,
          trigger = _this$props2.trigger,
          app = _this$props2.app,
          children = _this$props2.children,
          onSuccess = _this$props2.onSuccess,
          ampData = _this$props2.ampData,
          data = _objectWithoutProperties(_this$props2, ["event", "trigger", "app", "children", "onSuccess", "ampData"]);

      setImmediate(
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return analytics.fire(e, data);

              case 2:
                onSuccess();

              case 3:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      })));
    }
  }, {
    key: "createTriggerHandler",
    value: function createTriggerHandler(el, trigger, event) {
      var _this2 = this;

      var originalHandler = el.props[trigger];
      return function () {
        if (originalHandler) originalHandler.apply(void 0, arguments);

        _this2.fireEvent(event);
      };
    }
    /**
     * Intecepts the child's event handler prop corresponding to this.props.trigger
     * and returns the cloned child.
     * @return {React.Element}
     */

  }, {
    key: "attachEvent",
    value: function attachEvent() {
      var _this$props3 = this.props,
          amp = _this$props3.app.amp,
          el = _this$props3.children;

      if (el) {
        var triggers = this.getTriggers();
        var triggerHandlers = {};

        for (var propName in triggers) {
          triggerHandlers[propName] = this.createTriggerHandler(el, propName, triggers[propName]);
        }

        var props = _objectSpread({}, el.props, triggerHandlers);

        if (amp) {
          props['data-amp-id'] = this.id;
          props['data-vars-moov-test'] = 'foo';
        }

        return React.cloneElement(el, props);
      } else {
        return null;
      }
    }
    /**
     * Returns the value of the trigger prop normalized to an object.  If trigger is a string,
     * this function will return { [trigger]: event }
     */

  }, {
    key: "getTriggers",
    value: function getTriggers() {
      var _this$props4 = this.props,
          event = _this$props4.event,
          trigger = _this$props4.trigger;

      if (typeof trigger === 'string') {
        return _defineProperty({}, trigger, event);
      } else {
        return trigger;
      }
    }
    /**
     * Creates AMP event trigger objects based on this.props.event
     */

  }, {
    key: "createAmpTriggers",
    value: function createAmpTriggers(data) {
      var _this$props5 = this.props,
          event = _this$props5.event,
          children = _this$props5.children,
          ampData = _this$props5.ampData;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = getTargets()[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var target = _step.value;
          var handler = target[event];
          if (!target.getAmpAnalyticsType) continue;
          var type = target.getAmpAnalyticsType();

          if (handler && type) {
            var eventData = void 0; // Override send to capture the data that would be send instead of trying to send it

            target.send = function (data) {
              return eventData = data;
            }; // Call the method corresponding to the event name, this should result in a call to send


            handler.call(target, data);

            if (eventData) {
              if (!eventData.trigger && children) {
                // no need to set a selector if we don't have a child element
                // an example of this is pageview events
                eventData.selector = "[data-amp-id=\"".concat(this.id, "\"]");
              }

              this.configureAmpEvent(type, _objectSpread({
                on: eventData.selector ? 'click' : 'visible'
              }, eventData, {
                request: 'event'
              }, ampData));
            } else {
              console.log("WARNING: No data will be sent for the ".concat(event, " event when running in AMP because ").concat(target.constructor.name, " didn't return any data for this event."));
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
    /**
     * Adds an AMP analytics event trigger
     * @param {String} type An AMP analytics event type, e.g. googleanalytics
     * @param {Object} trigger The trigger descriptor object
     */

  }, {
    key: "configureAmpEvent",
    value: function configureAmpEvent(type, trigger) {
      var config = ampAnalyticsTypes[type];

      if (!config) {
        config = ampAnalyticsTypes[type] = {
          triggers: []
        };
      }

      config.triggers.push(trigger);
    }
  }]);

  return Track;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The name of the method to call on all configured analytics targets.
   * For example, "addedToCart".
   */
  event: PropTypes.string,

  /**
   * The name of the handler prop on child component to intercept.  Defaults to "onClick"
   */
  trigger: PropTypes.oneOfType([PropTypes.string, PropTypes.object]),

  /**
   * A function to call once the event has been successfully sent by all analytics targets.
   */
  onSuccess: PropTypes.func,

  /**
   * Additional data to send when tracking events in AMP.
   */
  ampData: PropTypes.object
}), _defineProperty(_class2, "defaultProps", {
  trigger: 'onClick',
  onSuccess: Function.prototype,
  ampData: {}
}), _temp)) || _class);
export { Track as default };
export function renderAmpAnalyticsTags(app) {
  try {
    return Object.keys(ampAnalyticsTypes).map(function (type) {
      var target = getTargets().find(function (t) {
        return t.getAmpAnalyticsType() === type;
      });
      var ampData = typeof target.getAmpAnalyticsData === 'function' ? target.getAmpAnalyticsData(app) : {};
      var attributes = target && target.getAmpAnalyticsAttributes ? target.getAmpAnalyticsAttributes() : {
        type: type
      };
      var attributesHtml = Object.keys(attributes).map(function (key) {
        return "".concat(key, "=\"").concat(escape(attributes[key]), "\"");
      }).join(' ');
      return "<amp-analytics ".concat(attributesHtml, ">") + "<script type=\"application/json\">".concat(JSON.stringify(merge({}, ampAnalyticsTypes[type], ampData)), "</script>") + "</amp-analytics>";
    }).join('\n');
  } finally {
    ampAnalyticsTypes = {};
  }
}
//# sourceMappingURL=Track.js.map