import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Snackbar from '@material-ui/core/Snackbar';
import Button from '@material-ui/core/Button';
import IconButton from '@material-ui/core/IconButton';
import CloseIcon from '@material-ui/icons/Close';
/**
 * A snackbar that automatically displays when a new version of the service worker is available.
 * By default the component only shows when the app is launched from the user's homescreen on android devices.
 * Additonal props are spread to the underlying material-ui Snackbar component
 */

var UpdateNotification =
/*#__PURE__*/
function (_Component) {
  _inherits(UpdateNotification, _Component);

  function UpdateNotification() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, UpdateNotification);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(UpdateNotification)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      notifyUpdate: false
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "handleNotifyClose", function () {
      _this.setState({
        notifyUpdate: false
      });
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "refresh", function () {
      window.location.reload();
    });

    return _this;
  }

  _createClass(UpdateNotification, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          message = _this$props.message,
          reloadButtonText = _this$props.reloadButtonText,
          others = _objectWithoutProperties(_this$props, ["message", "reloadButtonText"]);

      var notifyUpdate = this.state.notifyUpdate;
      return React.createElement(Snackbar, _extends({
        open: notifyUpdate,
        autoHideDuration: 6000,
        onClose: this.handleNotifyClose,
        message: message,
        action: [React.createElement(Button, {
          key: "undo",
          color: "secondary",
          size: "small",
          onClick: this.refresh
        }, reloadButtonText), React.createElement(IconButton, {
          key: "close",
          "aria-label": "Close",
          color: "inherit",
          onClick: this.handleNotifyClose
        }, React.createElement(CloseIcon, null))]
      }, others));
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      // published in registerServiceWorker.js
      document.addEventListener('moov-update-available', function () {
        console.log('new service worker installed');

        _this2.setState({
          notifyUpdate: true
        });
      });
    }
  }]);

  return UpdateNotification;
}(Component);

_defineProperty(UpdateNotification, "propTypes", {
  /**
   * The message to display
   */
  message: PropTypes.string,

  /**
   * The text for the reload button.
   */
  reloadButtonText: PropTypes.string
});

_defineProperty(UpdateNotification, "defaultProps", {
  message: 'An new version of this app is available.',
  reloadButtonText: 'RELOAD'
});

export { UpdateNotification as default };
//# sourceMappingURL=UpdateNotification.js.map