import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { Helmet } from 'react-helmet';
import withStyles from '@material-ui/core/styles/withStyles';
import { inject } from 'mobx-react';
/**
 * AMP ready video component
 *
 * Usage:
 *
 * <Video
 *  src="https://amp.dev/static/inline-examples/videos/kitten-playing.webm"
 *  controls
 * />
 *
 */

export var styles = function styles(theme) {
  return {
    root: {
      height: '100%',
      width: '100%',
      overflow: 'hidden'
    }
  };
};
var Video = (_dec = withStyles(styles, {
  name: 'RSFVideo'
}), _dec2 = inject(function (_ref) {
  var app = _ref.app;
  return {
    amp: app.amp
  };
}), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Video, _Component);

  function Video() {
    _classCallCheck(this, Video);

    return _possibleConstructorReturn(this, _getPrototypeOf(Video).apply(this, arguments));
  }

  _createClass(Video, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          classes = _this$props.classes,
          amp = _this$props.amp,
          props = _objectWithoutProperties(_this$props, ["children", "classes", "amp"]);

      var Tag = amp ? 'amp-video' : 'video';

      var tagProps = _objectSpread(_defineProperty({}, amp ? 'class' : 'className', classes.root), props); // Layout must be declared in AMP, so we use "fill" by default if not defined


      if (amp && !props.height && !props.width && !props.layout) {
        tagProps.layout = 'fill';
      }

      return React.createElement(React.Fragment, null, amp && React.createElement(Helmet, null, React.createElement("script", {
        async: true,
        "custom-element": "amp-video",
        src: "https://cdn.ampproject.org/v0/amp-video-0.1.js"
      })), React.createElement(Tag, tagProps, children));
    }
  }]);

  return Video;
}(Component), _defineProperty(_class2, "defaultProps", {
  controls: true
}), _temp)) || _class) || _class);
export { Video as default };
//# sourceMappingURL=Video.js.map