import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import Typography from '@material-ui/core/Typography';
import withStyles from '@material-ui/core/styles/withStyles';
import ExpandLess from '@material-ui/icons/ExpandLess';
import ExpandMore from '@material-ui/icons/ExpandMore';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import AmpAccordion from './AmpAccordion';
export var styles = function styles(theme) {
  return {
    section: {
      boxShadow: 'none',
      borderBottom: "1px solid ".concat(theme.palette.divider),
      background: 'transparent'
    },
    title: {
      backgroundColor: 'transparent',
      padding: '12px 15px',
      borderStyle: 'none',
      outlineWidth: 0
    },
    toggle: {
      position: 'absolute',
      right: '18px',
      top: '13px'
    },
    expand: {
      display: 'block',
      'section[expanded] &': {
        display: 'none'
      }
    },
    collapse: {
      display: 'none',
      'section[expanded] &': {
        display: 'block'
      }
    },
    body: {
      backgroundColor: 'transparent',
      padding: "0 ".concat(theme.margins.container, "px")
    }
  };
};
/**
 * An AMP-compatible expandable section based on amp-accordion.
 */

var AmpExpandableSection = (_dec = withStyles(styles, {
  name: 'RSFAmpExpandableSection'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpExpandableSection, _Component);

  function AmpExpandableSection() {
    _classCallCheck(this, AmpExpandableSection);

    return _possibleConstructorReturn(this, _getPrototypeOf(AmpExpandableSection).apply(this, arguments));
  }

  _createClass(AmpExpandableSection, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          classes = _this$props.classes,
          expanded = _this$props.expanded,
          _this$props$children = _this$props.children,
          children = _this$props$children === void 0 ? [] : _this$props$children,
          title = _this$props.title,
          ExpandIcon = _this$props.ExpandIcon,
          CollapseIcon = _this$props.CollapseIcon,
          expandedSectionId = _this$props.expandedSectionId;

      if (ExpandIcon === ExpandMore) {
        CollapseIcon = ExpandLess;
      }

      var sectionAttributes = {};
      if (expanded) sectionAttributes.expanded = '';
      var section = React.createElement("section", _extends({
        className: classes.section
      }, sectionAttributes), React.createElement(Typography, {
        variant: "subtitle1",
        component: "h3",
        className: classes.title
      }, title, React.createElement(ExpandIcon, {
        className: classnames(classes.toggle, classes.expand)
      }), React.createElement(CollapseIcon, {
        className: classnames(classes.toggle, classes.collapse)
      })), React.createElement("div", {
        className: classes.body
      }, children));

      if (expandedSectionId !== undefined) {
        return section;
      }

      return React.createElement(AmpAccordion, null, section);
    }
  }]);

  return AmpExpandableSection;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The title for the header of the expandable section
   */
  title: PropTypes.oneOfType([PropTypes.string, PropTypes.element]),

  /**
   * Set to true to expand the panel
   */
  expanded: PropTypes.bool,

  /**
   * The icon to use for collapsed groups
   */
  ExpandIcon: PropTypes.func,

  /**
   * The icon to use for expanded groups
   */
  CollapseIcon: PropTypes.func,

  /**
   * Expanded section ID used by accordion
   */
  expandedSectionId: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  expanded: false,
  ExpandIcon: ExpandMore,
  CollapseIcon: ExpandLess
}), _temp)) || _class);
export { AmpExpandableSection as default };
//# sourceMappingURL=AmpExpandableSection.js.map