import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { Helmet } from 'react-helmet';
import { inject } from 'mobx-react';
import LoadMask from '../LoadMask';
import withStyles from '@material-ui/core/styles/withStyles';
import { Provider } from 'mobx-react';
import PropTypes from 'prop-types';
export var styles = function styles(theme) {
  return {
    mask: {
      display: 'none',
      '.amp-form-submitting &, .moov-amp-form-mask &': {
        display: 'flex'
      }
    }
  };
};
/**
 * An AMP-compatible form.  When not rendering AMP content, this component renders a simple div.
 * This component will automatically cover itself with a modal loading spinner when submitting.
 */

var AmpForm = (_dec = inject(function (_ref) {
  var app = _ref.app,
      nextId = _ref.nextId,
      ampStateId = _ref.ampStateId;
  return {
    app: app,
    nextId: nextId,
    ampStateId: ampStateId
  };
}), _dec2 = withStyles(styles, {
  name: 'RSFAmpForm'
}), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpForm, _Component);

  function AmpForm(_ref2) {
    var _this;

    var id = _ref2.id,
        nextId = _ref2.nextId,
        app = _ref2.app;

    _classCallCheck(this, AmpForm);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AmpForm).call(this));
    _this.id = id || (app.amp ? "rsf-form-".concat(nextId()) : null);
    return _this;
  }

  _createClass(AmpForm, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          on = _this$props.on,
          ampStateId = _this$props.ampStateId,
          app = _this$props.app,
          mask = _this$props.mask,
          classes = _this$props.classes,
          className = _this$props.className,
          method = _this$props.method,
          target = _this$props.target,
          id = _this$props.id,
          children = _this$props.children,
          action = _this$props.action,
          nextId = _this$props.nextId,
          others = _objectWithoutProperties(_this$props, ["on", "ampStateId", "app", "mask", "classes", "className", "method", "target", "id", "children", "action", "nextId"]);

      var bind = others['amp-bind'];
      var validation = others['custom-validation-reporting'];

      if (app.amp) {
        // add event handler for valid state to display the mask when submitting
        // we do this because the submit event doesn't work when method=get
        if (method.toLowerCase() === 'get' && (validation == null || validation == 'show-first-on-submit')) {
          on = (on ? on + ',' : '') + "valid:AMP.setState({ ".concat(ampStateId, ": { ___moov_submitting: true }})");
          bind = (bind ? bind + ',' : '') + "class=>".concat(ampStateId, ".___moov_submitting ? 'moov-amp-form-mask' : ''");
        }

        return React.createElement(Provider, {
          ampFormId: this.id
        }, React.createElement("form", _extends({
          id: this.id,
          "data-id": this.id,
          method: method,
          target: target,
          className: className
        }, _defineProperty({}, method === 'post' ? 'action-xhr' : 'action', action), others, {
          on: on,
          "amp-bind": bind
        }), React.createElement(Helmet, null, React.createElement("script", {
          async: true,
          "custom-element": "amp-form",
          src: "https://cdn.ampproject.org/v0/amp-form-0.1.js"
        })), mask && React.createElement(LoadMask, {
          className: classes.mask
        }), children));
      } else {
        return React.createElement("form", others, children);
      }
    }
  }]);

  return AmpForm;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The id for the amp-form element.  If left blank a unique id will automatically be generated.
   */
  id: PropTypes.string,

  /**
   * The form's action attribute. Defaults to "_top".
   */
  target: PropTypes.string,

  /**
   * The HTTP method to use.  Defaults to "get".
   */
  method: PropTypes.oneOf(['get', 'post']),

  /**
   * Set to false to not show the mask when submitting.  Defaults to true.
   */
  mask: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  target: '_top',
  method: 'get',
  mask: true
}), _temp)) || _class) || _class);
export { AmpForm as default };
//# sourceMappingURL=AmpForm.js.map