import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component } from 'react';
import { Helmet } from 'react-helmet';
import classnames from 'classnames';
import withStyles from '@material-ui/core/styles/withStyles';
import { inject } from 'mobx-react';
import PropTypes from 'prop-types';
import Video from '../Video';
export var styles = function styles(theme) {
  return {
    root: {
      height: '300px',
      width: '450px',
      position: 'relative',
      '& > *': {
        paddingBottom: 'none'
      },
      '& *[role=button]': {
        borderRadius: '50%',
        opacity: '0.5',
        outline: 'none',
        backgroundColor: 'rgba(0,0,0,0.3)'
      }
    },
    // This fixes the issue where images do not show up sometimes when amp-carousel is placed in
    // a div with display: flex.  See https://github.com/ampproject/amphtml/issues/14519
    rootImportant: {
      '&$root': {
        display: 'block'
      }
    },
    carouselWrap: {
      height: 'calc(100% - 65px)',
      position: 'relative'
    },
    thumbnails: {
      marginTop: '10px',
      whiteSpace: 'nowrap',
      display: 'flex',
      alignItems: 'stretch',
      maxWidth: '100%',
      overflowX: 'auto',
      overflowY: 'hidden'
    },
    thumbnailsWrap: {
      justifyContent: 'center',
      display: 'flex',
      margin: 'auto',
      height: '70px',
      width: '100%',
      position: 'relative',
      // Since the thumbnails are dynamically fetched, we are letting
      // the wrapper fill the space and centering the thumbnails
      // with a inner AMP component
      '& amp-list div[role=list]': {
        display: 'flex',
        justifyContent: 'center'
      }
    },
    thumbnail: {
      height: '70px',
      width: '50px',
      position: 'relative',
      margin: '0 2px',
      border: 'none',
      outline: 'none',
      background: 'none',
      opacity: 0.7,
      '& img': {
        objectFit: 'contain'
      }
    },
    thumbnailSelected: {
      opacity: 1
    },
    thumbnailSelectedLine: {
      borderBottom: '3px solid #d32f2f',
      position: 'absolute',
      bottom: 0,
      left: 0,
      width: '50px'
    },
    dot: {},
    dots: {},
    dotSelected: {},
    hidden: {
      display: 'none'
    },
    '@global': {
      'amp-lightbox-gallery div[aria-label="Gallery"]': {
        display: 'none'
      }
    }
  };
};
/**
 * An AMP-compatible image switcher with pinch and zoom.
 */

var AmpImageSwitcher = (_dec = withStyles(styles, {
  name: 'RSFAmpImageSwitcher'
}), _dec2 = inject('nextId', 'ampStateId', 'app'), _dec(_class = _dec2(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpImageSwitcher, _Component);

  function AmpImageSwitcher(_ref) {
    var _this;

    var id = _ref.id,
        nextId = _ref.nextId;

    _classCallCheck(this, AmpImageSwitcher);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AmpImageSwitcher).call(this));
    id = id || nextId();
    _this.id = id || "moov-image-switcher-".concat(id);
    _this.ampStateId = "moovImageSwitcherState".concat(id);
    return _this;
  }

  _createClass(AmpImageSwitcher, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          type = _this$props.type,
          arrows = _this$props.arrows,
          indicators = _this$props.indicators,
          ampStateId = _this$props.ampStateId,
          ampStateProperty = _this$props.ampStateProperty,
          product = _this$props.product,
          images = _this$props.images,
          thumbnails = _this$props.thumbnails,
          classes = _this$props.classes,
          className = _this$props.className,
          app = _this$props.app;
      var id = this.id; // This endpoint is only used to give AMP a valid initial `src` for AMP lists

      var initialStateEndpoint = "/images/".concat(product.id, "/").concat(product && product.color && product.color.length ? product.color[0].id : '000000', ".json");

      var Carousel = function Carousel(_ref2) {
        var children = _ref2.children,
            props = _objectWithoutProperties(_ref2, ["children"]);

        return React.createElement("amp-carousel", _extends({
          controls: arrows ? true : undefined,
          id: id,
          lightbox: true,
          layout: "fill",
          type: type,
          loop: true,
          "amp-bind": "slide=> ".concat(ampStateId, ".").concat(ampStateProperty),
          on: "slideChange:AMP.setState({ ".concat(ampStateId, ": { ").concat(ampStateProperty, ": event.index } })")
        }, props), children);
      };

      var Template = function Template(_ref3) {
        var children = _ref3.children,
            props = _objectWithoutProperties(_ref3, ["children"]);

        return React.createElement("amp-list", _extends({
          layout: "fill",
          src: initialStateEndpoint,
          "amp-bind": "src=>'/images/".concat(product.id, "/' + moovAmpState.color.selected.id + '.json'")
        }, props), React.createElement("template", {
          type: "amp-mustache"
        }, children));
      };

      var BeforeInteracted = function BeforeInteracted(_ref4) {
        var children = _ref4.children;
        return React.createElement("div", {
          "amp-bind": "class=>".concat(ampStateId, ".colorInteracted ? '").concat(classes.hidden, "' : ''")
        }, children);
      };

      var AfterInteracted = function AfterInteracted(_ref5) {
        var children = _ref5.children;
        return React.createElement("div", {
          className: classes.hidden,
          "amp-bind": "class=>!".concat(ampStateId, ".colorInteracted ? '").concat(classes.hidden, "' : ''")
        }, children);
      };

      var Thumbnail = function Thumbnail(_ref6) {
        var src = _ref6.src,
            alt = _ref6.alt,
            index = _ref6.index;
        return React.createElement("button", {
          key: src,
          type: "button",
          on: "tap:AMP.setState({ ".concat(ampStateId, ": { ").concat(ampStateProperty, ": ").concat(index, " }})"),
          className: classnames(classes.thumbnail, _defineProperty({}, classes.thumbnailSelected, index === 0)),
          "amp-bind": "class=>".concat(ampStateId, ".").concat(ampStateProperty, " == ").concat(index, " ? '").concat(classes.thumbnail, " ").concat(classes.thumbnailSelected, "' : '").concat(classes.thumbnail, "'")
        }, React.createElement("amp-img", {
          layout: "fill",
          src: src,
          alt: alt
        }), React.createElement("div", {
          className: index === 0 && classes.thumbnailSelectedLine,
          "amp-bind": "class=>".concat(ampStateId, ".").concat(ampStateProperty, " == ").concat(index, " ? '").concat(classes.thumbnailSelectedLine, "' : ''")
        }));
      };

      return React.createElement("div", {
        className: classnames(className, classes.root, classes.rootImportant)
      }, React.createElement(Helmet, null, React.createElement("script", {
        async: true,
        "custom-element": "amp-list",
        src: "https://cdn.ampproject.org/v0/amp-list-0.1.js"
      }), React.createElement("script", {
        async: true,
        "custom-template": "amp-mustache",
        src: "https://cdn.ampproject.org/v0/amp-mustache-0.2.js"
      }), React.createElement("script", {
        async: true,
        "custom-element": "amp-carousel",
        src: "https://cdn.ampproject.org/v0/amp-carousel-0.1.js"
      }), React.createElement("script", {
        async: true,
        "custom-element": "amp-lightbox-gallery",
        src: "https://cdn.ampproject.org/v0/amp-lightbox-gallery-0.1.js"
      })), React.createElement("amp-state", {
        id: ampStateId // Do not refresh this state until a color has been interacted with
        ,
        "amp-bind": "src=>".concat(ampStateId, ".colorInteracted ? '/images/").concat(product.id, "' + moovAmpState.color.selected.id + '.json' : null")
      }), React.createElement("div", {
        className: classes.carouselWrap
      }, React.createElement(BeforeInteracted, null, React.createElement(Carousel, null, images.map(function (_ref7) {
        var src = _ref7.src,
            alt = _ref7.alt,
            video = _ref7.video;
        return video ? React.createElement(Video, {
          src: src,
          alt: alt,
          key: src
        }) : React.createElement("amp-img", {
          key: src,
          src: src,
          layout: "fill",
          alt: alt
        });
      }))), React.createElement(AfterInteracted, null, React.createElement(Template, {
        items: ".",
        "single-item": true
      }, React.createElement(Carousel, null, '{{#images}}', '{{#video}}', React.createElement(Video, {
        src: "{{src}}",
        layout: "fill",
        alt: "{{alt}}"
      }), '{{/video}}', '{{^video}}', React.createElement("amp-img", {
        src: "{{.}}",
        layout: "fill",
        alt: "test"
      }), '{{/video}}', '{{/images}}'))), indicators && React.createElement("div", {
        className: classes.dots
      }, images.map(function (_ref8, i) {
        var src = _ref8.src;
        return React.createElement("div", {
          key: src,
          "amp-bind": "class=>".concat(ampStateId, ".").concat(ampStateProperty, " == ").concat(i, " ? '").concat(classes.dot, " ").concat(classes.dotSelected, "' : '").concat(classes.dot, "'"),
          className: classnames(classes.dot, _defineProperty({}, classes.dotSelected, i === 0))
        });
      }))), thumbnails && thumbnails.length > 0 && React.createElement("div", {
        className: classes.thumbnails
      }, React.createElement("div", {
        className: classes.thumbnailsWrap
      }, React.createElement(BeforeInteracted, null, thumbnails.map(function (_ref9, index) {
        var src = _ref9.src,
            alt = _ref9.alt;
        return React.createElement(Thumbnail, {
          src: src,
          alt: alt,
          index: index
        });
      })), React.createElement(AfterInteracted, null, React.createElement(Template, {
        items: "thumbnails"
      }, React.createElement(Thumbnail, {
        src: "{{.}}",
        alt: "thumbnail",
        index: "".concat(ampStateId, ".thumbnails.indexOf(\"{{.}}\")")
      }))))));
    }
  }]);

  return AmpImageSwitcher;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The amp-carousel type.  Can be "slides" or "carousel".  Defaults to "slides".
   */
  type: PropTypes.oneOf(['slides', 'carousel']),

  /**
   * Set to true to display dots indicated which image in the series is selected.  Defaults to false
   */
  indicators: PropTypes.bool,

  /**
   * The property in the amp state to bind to.  Defaults to "selectedImage"
   */
  ampStateProperty: PropTypes.string,

  /**
   * Set to true to display left and right arrows.  Defaults to false
   */
  arrows: PropTypes.bool
}), _defineProperty(_class2, "defaultProps", {
  type: 'slides',
  indicators: false,
  ampStateProperty: 'selectedImage',
  arrows: false
}), _temp)) || _class) || _class);
export { AmpImageSwitcher as default };
//# sourceMappingURL=AmpImageSwitcher.js.map