import "core-js/modules/web.dom.iterable";
import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _dec2, _dec3, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { inject } from 'mobx-react';
import withStyles from '@material-ui/core/styles/withStyles';
import withTheme from '@material-ui/core/styles/withTheme';
import { Helmet } from 'react-helmet';
import AmpMenuBody from '../amp/AmpMenuBody';
import classnames from 'classnames';
import AmpState from './AmpState';
export var styles = function styles(theme) {
  return {
    root: {
      position: 'relative',
      marginTop: theme.headerHeight,
      height: "calc(100vh - ".concat(theme.headerHeight, "px)"),
      borderTop: "1px solid ".concat(theme.palette.divider),
      backgroundColor: theme.palette.background.paper,
      boxShadow: '10px 2px 10px -5px rgba(0, 0, 0, 0.2)',
      paddingBottom: '64px',
      '& h3': {
        backgroundColor: theme.palette.background.paper
      },
      '& .expanded > .menu-item': {
        color: theme.palette.secondary.contrastText,
        backgroundColor: theme.palette.secondary.main,
        borderColor: theme.palette.secondary.main,
        '& svg': {
          fill: theme.palette.secondary.contrastText
        }
      },
      '& a': {
        color: theme.typography.body1.color
      },
      '& ~ div[class*="amphtml-sidebar-mask"]': {
        background: 'rgba(0, 0, 0, 0.5)',
        opacity: 1
      }
    }
  };
};
/**
 * An AMP-compatible menu based on amp-sidebar.
 *
 * In addition to the CSS classes that can be overridden of menu subcomponents, you can also
 * assign specific classes to individual menu items by specifying a value for the `className`
 * field on any instance of `MenuItemModel`.
 */

var AmpMenu = (_dec = withTheme(), _dec2 = withStyles(styles, {
  name: 'RSFAmpMenu'
}), _dec3 = inject(function (_ref) {
  var app = _ref.app;
  return {
    menu: app.menu
  };
}), _dec(_class = _dec2(_class = _dec3(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpMenu, _Component);

  function AmpMenu() {
    _classCallCheck(this, AmpMenu);

    return _possibleConstructorReturn(this, _getPrototypeOf(AmpMenu).apply(this, arguments));
  }

  _createClass(AmpMenu, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          menu = _this$props.menu,
          classes = _this$props.classes,
          theme = _this$props.theme,
          className = _this$props.className,
          align = _this$props.align,
          drawerWidth = _this$props.drawerWidth,
          others = _objectWithoutProperties(_this$props, ["id", "menu", "classes", "theme", "className", "align", "drawerWidth"]);

      var root = menu.levels[0];
      if (!root) return null;
      var bodies = [React.createElement(AmpMenuBody, _extends({}, others, {
        key: 0,
        drawerWidth: drawerWidth,
        root: root,
        depth: 0,
        path: [],
        classes: classes,
        theme: theme // Force expanders in AMP
        ,
        useExpanders: true
      }))]; // Build first level menu screens

      root.items.forEach(function (node, index) {
        if (node.items) {
          bodies.push(React.createElement(AmpMenuBody, _extends({}, others, {
            key: index + 1,
            drawerWidth: drawerWidth,
            root: node,
            depth: 1,
            path: [index],
            classes: classes,
            theme: theme // Force expanders in AMP
            ,
            useExpanders: true
          })));
        }
      });
      return React.createElement(Fragment, null, React.createElement(AmpState, {
        id: "rsfMenu",
        initialState: {
          open: false
        }
      }), React.createElement(Helmet, {
        key: "helmet"
      }, React.createElement("script", {
        async: true,
        "custom-element": "amp-sidebar",
        src: "https://cdn.ampproject.org/v0/amp-sidebar-0.1.js"
      }), React.createElement("script", {
        async: true,
        "custom-element": "amp-bind",
        src: "https://cdn.ampproject.org/v0/amp-bind-0.1.js"
      }), React.createElement("style", {
        "amp-custom": true
      }, "\n            #".concat(id, " {\n              width: ").concat(drawerWidth, "px;\n            }\n          "))), React.createElement("amp-sidebar", {
        key: "sidebar",
        id: id,
        class: classnames(className, classes.root),
        layout: "nodisplay",
        side: align,
        on: "sidebarClose:AMP.setState({ rsfMenu: { open: false } })"
      }, bodies));
    }
  }]);

  return AmpMenu;
}(Component), _defineProperty(_class2, "defaultProps", {
  id: 'moov_menu'
}), _temp)) || _class) || _class) || _class);
export { AmpMenu as default };
//# sourceMappingURL=AmpMenu.js.map