import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { Helmet } from 'react-helmet';
import withStyles from '@material-ui/core/styles/withStyles';
import PropTypes from 'prop-types';
export var styles = function styles(theme) {
  return {
    root: {
      zIndex: theme.zIndex.amp.modal + 2,
      // zIndex of AppBar's withAmp + 1
      backgroundColor: 'rgba(255, 255, 255, .8)'
    }
  };
};
/**
 * An AMP-compatible modal based on `<amp-lightbox>`
 *
 * All props not specifically documented here are spread to the `<amp-lightbox>` element.
 * More info about amp-lightbox on AMP docs: https://www.ampproject.org/docs/reference/components/amp-lightbox
 *
 * Usage example:
 *
 *  <button on="tap:modal">Open Modal</button>
 *
 *  <AmpModal id="modal">
 *    <button on="tap:modal.close">Close Modal</button>
 *    <div>Modal content ...</div>
 *  </AmpModal>
 */

var AmpModal = (_dec = withStyles(styles, {
  name: 'RSFAmpModal'
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpModal, _Component);

  function AmpModal() {
    _classCallCheck(this, AmpModal);

    return _possibleConstructorReturn(this, _getPrototypeOf(AmpModal).apply(this, arguments));
  }

  _createClass(AmpModal, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          animateIn = _this$props.animateIn,
          classes = _this$props.classes,
          children = _this$props.children,
          others = _objectWithoutProperties(_this$props, ["id", "animateIn", "classes", "children"]);

      if (!id) {
        return new Error('Prop `id` is required for `AmpModal` component');
      }

      return React.createElement(Fragment, null, React.createElement(Helmet, {
        key: "helmet"
      }, React.createElement("script", {
        async: true,
        "custom-element": "amp-lightbox",
        src: "https://cdn.ampproject.org/v0/amp-lightbox-0.1.js"
      })), React.createElement("amp-lightbox", _extends({
        key: "lightbox",
        layout: "nodisplay",
        id: id,
        "animate-in": animateIn,
        class: classes.root
      }, others), children));
    }
  }]);

  return AmpModal;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The id for the amp-lightbox element.
   * This is REQUIRED attribute.
   */
  id: PropTypes.string,

  /**
   * Defines the style of animation for opening the lightbox.
   * By default, this will be set to `fade-in`.
   * Valid values are `fade-in`, `fly-in-bottom` and `fly-in-top`.
   *
   * Note: The `fly-in-*` animation presets modify the transform property of the amp-lightbox element.
   * Do not rely on transforming the amp-lightbox element directly.
   * If you need to apply a transform, set it on a nested element instead.
   */
  animateIn: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  animateIn: 'fade-in'
}), _temp)) || _class);
export { AmpModal as default };
//# sourceMappingURL=AmpModal.js.map