import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { PropTypes } from 'prop-types';
import { Provider, inject } from 'mobx-react';
import { Helmet } from 'react-helmet';
/**
 * A container that initialize amp state to be consumed by child components.  Components that support AMP functionality
 * like QuantitySelector and TapPanel must be inside an AmpState element.
 */

var AmpState = (_dec = inject(function (_ref) {
  var app = _ref.app;
  return {
    amp: app.amp
  };
}), _dec(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(AmpState, _Component);

  function AmpState() {
    _classCallCheck(this, AmpState);

    return _possibleConstructorReturn(this, _getPrototypeOf(AmpState).apply(this, arguments));
  }

  _createClass(AmpState, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          id = _this$props.id,
          amp = _this$props.amp,
          initialState = _this$props.initialState,
          children = _this$props.children;
      return React.createElement(Provider, {
        ampStateId: id
      }, amp ? React.createElement(Fragment, null, React.createElement(Helmet, null, React.createElement("script", {
        async: true,
        "custom-element": "amp-bind",
        src: "https://cdn.ampproject.org/v0/amp-bind-0.1.js"
      })), React.createElement("amp-state", {
        id: id
      }, React.createElement("script", {
        type: "application/json",
        dangerouslySetInnerHTML: {
          __html: JSON.stringify(initialState.toJSON ? initialState.toJSON() : initialState)
        }
      })), children) : React.createElement(Fragment, null, children));
    }
  }]);

  return AmpState;
}(Component), _defineProperty(_class2, "propTypes", {
  /**
   * The initial values for the amp-state.  Defaults to `{}`
   */
  initialState: PropTypes.object,

  /**
   * An id for the root amp state object. Defaults to "moovAmpState".
   */
  id: PropTypes.string
}), _defineProperty(_class2, "defaultProps", {
  initialState: {},
  id: 'moovAmpState'
}), _temp)) || _class);
export { AmpState as default };
//# sourceMappingURL=AmpState.js.map