import "core-js/modules/web.dom.iterable";
import "core-js/modules/es6.array.iterator";

/**
 * @license
 * Copyright © 2017-2018 Moov Corporation.  All rights reserved.
 */
import { createMuiTheme } from '@material-ui/core/styles';
import merge from 'lodash/merge';
export default function createTheme() {
  var values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var config = {};
  merge(config, {
    typography: {
      useNextVariants: true
    },
    palette: {// primary
      // secondary
    },
    margins: {
      // vertical margin on Container component
      container: 15,
      // horizontal margin on Row component
      row: 15
    },
    zIndex: {
      amp: {
        // the z-index for modals in amp
        modal: 2147483646
      }
    },
    // The height of the app header
    headerHeight: 64,
    // Width of Menu Drawer - this property is used to render the AMP version of the menu correctly
    drawerWidth: 330,
    // Override the icon for all expanders in collapsed state - this should be a React component class, for example @material-ui/icons/Add
    ExpandIcon: null,
    // Override the icon for all expanders in expanded state - this should be a React component classm for example @material-ui/icons/Remove
    CollapseIcon: null
  }, values);
  var theme = createMuiTheme(config);

  if (!theme.maxWidth) {
    theme.maxWidth = "".concat(theme.breakpoints.values.lg, "px");
  }

  return theme;
}
//# sourceMappingURL=createTheme.js.map