import _extends from "@babel/runtime/helpers/extends";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

var _dec, _class, _class2, _temp;

/**
 * @license
 * Copyright © 2017-2019 Moov Corporation.  All rights reserved.
 */
import React, { Component, Fragment } from 'react';
import { observer, inject } from 'mobx-react';
import List from '@material-ui/core/List';
import Item from './Item';
import MenuContext from './MenuContext';
import LeafHeader from './LeafHeader';
import LeafFooter from './LeafFooter';
var Body = (_dec = inject('app'), _dec(_class = observer(_class = (_temp = _class2 =
/*#__PURE__*/
function (_Component) {
  _inherits(Body, _Component);

  function Body() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Body);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Body)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "goBack", function () {
      _this.props.app.menu.goBack();
    });

    return _this;
  }

  _createClass(Body, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          rootHeader = _this$props.rootHeader,
          rootFooter = _this$props.rootFooter,
          renderLeafHeader = _this$props.renderLeafHeader,
          renderLeafFooter = _this$props.renderLeafFooter,
          simple = _this$props.simple,
          drawerWidth = _this$props.drawerWidth,
          children = _this$props.children,
          menu = _this$props.app.menu;
      var levels = menu.levels,
          level = menu.level;
      var position = -drawerWidth * level;
      var classes = this.context.classes;
      return React.createElement(Fragment, null, children, simple ? this.renderSimple() : React.createElement("div", {
        className: classes.bodyWrap,
        style: {
          transform: "translateX(".concat(position, "px)"),
          flex: 1
        }
      }, levels.map(function (list, depth) {
        return React.createElement(List, {
          style: {
            width: "".concat(drawerWidth, "px")
          },
          classes: {
            root: classes.list,
            padding: classes.padding
          },
          key: depth
        }, list.root ? rootHeader : React.createElement(LeafHeader, {
          classes: classes,
          goBack: _this2.goBack,
          list: list,
          render: renderLeafHeader
        }), list.items && list.items.map(function (item, key) {
          return React.createElement(Item, _extends({}, _this2.props, {
            item: item,
            key: key,
            depth: depth,
            classes: {
              list: classes.list,
              listItem: classes.listItem
            }
          }));
        }), list.root ? rootFooter : React.createElement(LeafFooter, {
          list: list,
          render: renderLeafFooter
        }));
      })));
    }
    /**
     * Renders the menu as a simple list of expandable sections
     * @return {List}
     */

  }, {
    key: "renderSimple",
    value: function renderSimple() {
      var _this3 = this;

      var _this$props2 = this.props,
          rootHeader = _this$props2.rootHeader,
          rootFooter = _this$props2.rootFooter,
          menu = _this$props2.app.menu;
      var classes = this.context.classes;
      var root = menu && menu.levels && menu.levels[0];
      if (!root) return null;
      return React.createElement(List, {
        classes: {
          padding: classes.list
        }
      }, rootHeader, root.items.map(function (item, i) {
        return React.createElement(Item, _extends({}, _this3.props, {
          depth: 1,
          item: item,
          key: i
        }));
      }), rootFooter);
    }
  }]);

  return Body;
}(Component), _defineProperty(_class2, "contextType", MenuContext), _temp)) || _class) || _class);
export { Body as default };
//# sourceMappingURL=Body.js.map