import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import "core-js/modules/es7.symbol.async-iterator";
import "core-js/modules/es6.symbol";
import "core-js/modules/web.dom.iterable";
import "core-js/modules/es6.regexp.split";

/**
 * @license
 * Copyright © 2017-2019 Moov Corporation.  All rights reserved.
 */

/**
 * Gets the value of a cookie by name.  Will return undefined if the cookie is present.
 * @param {String} name The name of the cookie
 * @return {String} The value of the cookie
 */
export function getCookie(name) {
  var pairs = document.cookie.split(/;\s*/);
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = pairs[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var pair = _step.value;

      var _pair$split = pair.split('='),
          _pair$split2 = _slicedToArray(_pair$split, 2),
          k = _pair$split2[0],
          v = _pair$split2[1];

      if (decodeURIComponent(k) === name) {
        return decodeURIComponent(v);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return undefined;
}
//# sourceMappingURL=cookie.js.map